--
-- PA1
--
-- @author  DD ModPassion
-- @date  04/06/2017
--
-- Copyright (C) DD ModPassion, Confidential, All Rights Reserved.
PA1 = {};
function PA1.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;
function PA1:preLoad(savegame)
	self.setStatoPA1 = PA1.setStatoPA1;
end;
function PA1:load(savegame)
	self.pedanaChiusa = 1;
	self.pedanaAperta = 3;
	self.posizionePedana = self.pedanaChiusa;
	self.teloChiuso = 1;
	self.teloAperto = 3;
	self.posizioneTelo = self.teloChiuso;
	self.tubiPresenti = 1;
	self.tubiAssenti = 3;
	self.posizioneTubi = self.tubiAssenti;
	self.distanzaMod = 2;
	self.modAssenti = 0;
	self.modPresenti = 2;
	self.ricercaMod = self.modAssenti;
	self.tuboTrasporto = {};
	self.tuboTrasporto.tuboTrasportoInput = nil;
	self.tuboTrasporto.terminale = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.tubiTrasporto#terminale"));
	self.tuboTrasporto.tubi = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.tubiTrasporto#tubi"));
	self.posizioneBase = 0;
	self.posizione150 = 150;
	self.posizione200 = 200;
	self.posizioneTubo = self.posizioneBase;
	self.posizioneXtubi = 0;
	self.posizioneYtubi = 0;
	self.tempoAttesa = 0;
	self.menuPA1Attivo = false;
	self.attacherVehicle = nil;
	self.modMagica = nil;
	self.menuMagicaAttivo = true;
	self.menuPrimo = 1;
	self.menuSecondo = 2;
	self.menuSelezionato = self.menuPrimo;
	self.configuration_PA1Altezza = Utils.getFilename("image/configuration_PA1Altezza.dds", self.baseDirectory);
	self.configuration_PA1Distanza = Utils.getFilename("image/configuration_PA1Distanza.dds", self.baseDirectory);
	self.drawMenuPA1Help = SpecializationUtil.callSpecializationsFunction("drawMenuPA1Help");
	local uiScale = 1.0;
	if g_gameSettings ~= nil
	and g_gameSettings.getValue ~= nil
	then
		uiScale = Utils.getNoNil(g_gameSettings:getValue("uiScale"), 1.0);
	end;
	self.menuPA1 = {};
	local i = 0;
	while true
	do
		local baseName = string.format("vehicle.menuPA1.impostazione(%d)", i);
		if not hasXMLProperty(self.xmlFile, baseName)
		then
			break;
		end;
		local entry = {};
		entry.name = {};
		local nome = getXMLString(self.xmlFile, baseName.."#name");
		entry.name[nome] = true;
		local width, height = getNormalizedScreenValues(200*uiScale, 200*uiScale);
		if	   i == 0
		then
			entry.overlay = Overlay:new("menu", self.configuration_PA1Altezza, 0, 0, width, height);
		else
			entry.overlay = Overlay:new("menu", self.configuration_PA1Distanza, 0, 0, width, height);
		end;
		entry.overlay:setColor(unpack(g_currentMission.helpBoxTextColor));
		if next(entry.name) ~= nil
		then
			entry.statusBarColor = {0.2122, 0.5271, 0.0307, 1};
			entry.statusBarColor2 = {0.2832, 0.0091, 0.0091, 1};
			local width, height = getNormalizedScreenValues(208*uiScale, 22*uiScale);
			entry.statusBar = StatusBar:new(g_baseUIFilename, g_colorBgUVs, nil, {0.0075, 0.0075, 0.0075, 1}, entry.statusBarColor2, nil, 0, 0, width, height);
			table.insert(self.menuPA1, entry);
		end;
		i = i + 1;
	end;
	self.menuPA1TextOffsetX, self.menuPA1TextOffsetY = getNormalizedScreenValues(28*uiScale, 7*uiScale);
	_, self.menuPA1HelpHeight = getNormalizedScreenValues(0, 22*uiScale);
	_, self.menuPA1HelpHeightOffset = getNormalizedScreenValues(0, 10*uiScale);
end;
function PA1:postLoad(savegame)
	local sceltaPedana = self.posizionePedana;
	local sceltaTelo = self.posizioneTelo;
	local sceltaTubi = self.posizioneTubi;
	local sceltaPosizioneXtubi = self.posizioneXtubi;
	local sceltaPosizioneYtubi = self.posizioneYtubi;
	if savegame ~= nil
	and not savegame.resetVehicles
	then
		sceltaTubi = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key.."#sceltaTubi"), self.posizioneTubi);
		sceltaPosizioneXtubi = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key.."#posizioneXtubi"), self.posizioneXtubi);
		sceltaPosizioneYtubi = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key.."#posizioneYtubi"), self.posizioneYtubi);
	end;
	self:setStatoPA1(sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi, true);
end;
function PA1:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'sceltaTubi="'..self.posizioneTubi..'" posizioneXtubi="'..self.posizioneXtubi..'" posizioneYtubi="'..self.posizioneYtubi..'"';
	return attributes, nil;
end;
function PA1.readStream(self, streamId, connection)
	if connection:getIsServer()
	then
		local sceltaPedana = streamReadInt8(streamId);
		local sceltaTelo = streamReadInt8(streamId);
		local sceltaTubi = streamReadInt8(streamId);
		local sceltaPosizioneXtubi = streamReadInt8(streamId);
		local sceltaPosizioneYtubi = streamReadInt8(streamId);
		self:setStatoPA1(sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi, true);
	end;
end;
function PA1.writeStream(self, streamId, connection)
	if not connection:getIsServer()
	then
		streamWriteInt8(streamId, self.posizionePedana);
		streamWriteInt8(streamId, self.posizioneTelo);
		streamWriteInt8(streamId, self.posizioneTubi);
		streamWriteInt8(streamId, self.posizioneXtubi);
		streamWriteInt8(streamId, self.posizioneYtubi);
	end;
end;
function PA1:delete()
end;
function PA1:mouseEvent(posX, posY, isDown, isUp, button)
end;
function PA1:keyEvent(unicode, sym, modifier, isDown)
end;
function PA1:update(dt)
	if g_currentMission.player ~= nil
	and g_currentMission.player.isEntered
	then
		local gx, gy, gz = getWorldTranslation(g_currentMission.player.rootNode);
		local mx, my, mz = getWorldTranslation(self.components[1].node);
		local px, py, pz = getWorldTranslation(self.components[2].node);
		if Utils.vector3Length(gx-mx, gy-my, gz-mz) < self.distanzaMod
		then
			if	   self.posizionePedana == self.pedanaChiusa
			then
				g_currentMission:addHelpButtonText(g_i18n:getText("01PA1"), InputBinding.PA1_letteraC);
				if InputBinding.hasEvent(InputBinding.PA1_letteraC)
				then
					self:setStatoPA1(self.pedanaAperta, self.posizioneTelo, self.posizioneTubi, self.posizioneXtubi, self.posizioneYtubi);
				end;
			elseif self.posizionePedana == self.pedanaAperta
			then
				g_currentMission:addHelpButtonText(g_i18n:getText("02PA1"), InputBinding.PA1_letteraC);
				if InputBinding.hasEvent(InputBinding.PA1_letteraC)
				then
					self:setStatoPA1(self.pedanaChiusa, self.posizioneTelo, self.posizioneTubi, self.posizioneXtubi, self.posizioneYtubi);
				end;
				if	   self.isCoverOpen
				then
					g_currentMission:addHelpButtonText(g_i18n:getText("action_closeCover"), InputBinding.TOGGLE_COVER);
					if InputBinding.hasEvent(InputBinding.TOGGLE_COVER)
					then
						self:setCoverState(not self.isCoverOpen);
					end;
				elseif not self.isCoverOpen
				then
					g_currentMission:addHelpButtonText(g_i18n:getText("action_openCover"), InputBinding.TOGGLE_COVER);
					if InputBinding.hasEvent(InputBinding.TOGGLE_COVER)
					then
						self:setCoverState(not self.isCoverOpen);
					end;
				end;
			end;
		end;
		if Utils.vector3Length(gx-mx, gy-my, gz-mz) < (self.distanzaMod + 4)
		then
			if self.posizioneTubi == self.tubiPresenti
			then
				if InputBinding.hasEvent(InputBinding.PA1_letteraM)
				then
					self.menuPA1Attivo = not self.menuPA1Attivo;
				end;
				if self.menuPA1Attivo
				then
					g_currentMission:addHelpButtonText(g_i18n:getText("08PA1"), InputBinding.PA1_letteraM);
					local helpHeight = 13*self.menuPA1HelpHeight + self.menuPA1HelpHeightOffset;
					g_currentMission:addHelpTextFunction(self.drawMenuPA1Help, self, helpHeight, nil);
					g_currentMission:addHelpButtonText(g_i18n:getText("05magica"), InputBinding.PA1_paginaSu, nil, GS_PRIO_HIGH);
					if InputBinding.hasEvent(InputBinding.PA1_paginaSu)
					then
						self.menuSelezionato = self.menuPrimo;
					end;
					g_currentMission:addHelpButtonText(g_i18n:getText("04magica"), InputBinding.PA1_paginaGiù, nil, GS_PRIO_HIGH);
					if InputBinding.hasEvent(InputBinding.PA1_paginaGiù)
					then
						self.menuSelezionato = self.menuSecondo;
					end;
					if	   self.menuSelezionato == self.menuPrimo
					then
						if self.posizioneYtubi < 30
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.PA1_numpadPiù);
							if InputBinding.hasEvent(InputBinding.PA1_numpadPiù)
							then
								self.posizioneYtubi = self.posizioneYtubi + 1;
							end;
						end;
						if self.posizioneYtubi > -30
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.PA1_numpadMeno);
							if InputBinding.hasEvent(InputBinding.PA1_numpadMeno)
							then
								self.posizioneYtubi = self.posizioneYtubi - 1;
							end;
						end;
					elseif self.menuSelezionato == self.menuSecondo
					then
						if self.posizioneXtubi < 30
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.PA1_numpadPiù);
							if InputBinding.hasEvent(InputBinding.PA1_numpadPiù)
							then
								self.posizioneXtubi = self.posizioneXtubi + 1;
							end;
						end;
						if self.posizioneXtubi > -30
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.PA1_numpadMeno);
							if InputBinding.hasEvent(InputBinding.PA1_numpadMeno)
							then
								self.posizioneXtubi = self.posizioneXtubi - 1;
							end;
						end;
					end;
					self:setStatoPA1(self.posizionePedana, self.posizioneTelo, self.posizioneTubi, self.posizioneXtubi, self.posizioneYtubi);
					if self.modMagica ~= nil
					then
						self.modMagica:setMenuMagicaAttivo(false);
					end;
				else
					g_currentMission:addHelpButtonText(g_i18n:getText("06PA1"), InputBinding.PA1_letteraM);
					if self.modMagica ~= nil
					then
						self.modMagica:setMenuMagicaAttivo(true);
					end;
				end;
			end;
		else
			if self.menuPA1Attivo == true
			then
				self.menuPA1Attivo = not self.menuPA1Attivo;
				if self.modMagica ~= nil
				then
					self.modMagica:setMenuMagicaAttivo(true);
				end;
			end;
		end;
		if	Utils.vector3Length(gx-mx, gy-my, gz-mz) < (self.distanzaMod + 3)
		and Utils.vector3Length(mx-px, my-py, mz-pz) < (self.distanzaMod + 3)
		and Utils.vector3Length(gx-px, gy-py, gz-pz) < self.distanzaMod
		and	self.ricercaMod == self.modPresenti
		then
			if	   self.posizioneTubi == self.tubiAssenti
			then
				g_currentMission:addHelpButtonText(g_i18n:getText("03PA1"), InputBinding.PA1_letteraI);
				if InputBinding.hasEvent(InputBinding.PA1_letteraI)
				then
					self:setStatoPA1(self.posizionePedana, self.posizioneTelo, self.tubiPresenti, self.posizioneXtubi, self.posizioneYtubi);
				end;
			elseif self.posizioneTubi == self.tubiPresenti
			then
				g_currentMission:addHelpButtonText(g_i18n:getText("04PA1"), InputBinding.PA1_letteraI);
				if InputBinding.hasEvent(InputBinding.PA1_letteraI)
				then
					self:setStatoPA1(self.posizionePedana, self.posizioneTelo, self.tubiAssenti, self.posizioneXtubi, self.posizioneYtubi);
				end;
			end;
		elseif Utils.vector3Length(gx-mx, gy-my, gz-mz) < (self.distanzaMod + 3)
		then
			g_currentMission:addExtraPrintText(g_i18n:getText('05PA1'));
		end;
	end;
	if self.isClient
	then
		if	 self.posizioneTubi == self.tubiPresenti
		and	 self.tuboTrasporto.tuboTrasportoInput ~= nil
		then
			setTranslation(self.tuboTrasporto.terminale, 0, 0, 0);
			local tuboTrasportoInputX, tuboTrasportoInputY, tuboTrasportoInputZ = getWorldTranslation(self.tuboTrasporto.tuboTrasportoInput);
			local terminaleX, terminaleY, terminaleZ = worldToLocal(self.tuboTrasporto.terminale, tuboTrasportoInputX, tuboTrasportoInputY, tuboTrasportoInputZ);
			setTranslation(self.tuboTrasporto.terminale, terminaleX, terminaleY, terminaleZ);
		end;
	end;
end;
function PA1:updateTick(dt)
	if self.isClient
	then
		local currentVehicle = self:getRootAttacherVehicle();
		local trovaMod = self.modAssenti;
		for _,implement in pairs(currentVehicle.attachedImplements)
		do
			if implement.object ~= nil
			then
				if	   string.match(implement.object.typeName, "magica") == "magica"
				then
					local inputAttacherJoints = implement.object.inputAttacherJoints[2];
					self.modMagica = implement.object;
					self.tuboTrasporto.tuboTrasportoInput = inputAttacherJoints.node;
					trovaMod = trovaMod + 1;
				elseif string.match(implement.object.typeName, "PA1") == "PA1"
				then
					trovaMod = trovaMod + 1;
				else
					currentVehicle = implement.object;
					for _,implement in pairs(currentVehicle.attachedImplements)
					do
						if implement.object ~= nil
						then
							if	   string.match(implement.object.typeName, "magica") == "magica"
							then
								local inputAttacherJoints = implement.object.inputAttacherJoints[2];
								self.modMagica = implement.object;
								self.tuboTrasporto.tuboTrasportoInput = inputAttacherJoints.node;
								trovaMod = trovaMod + 1;
							end;
						end;
					end;				
				end;
			end;
		end;
		self.ricercaMod = trovaMod;
		if	   self.ricercaMod == self.modPresenti
		and self.posizioneTubi == self.tubiPresenti
		then
			self.isSprayerTank = true;
			setTranslation(self.tuboTrasporto.tubi, -1.1-self.posizioneXtubi/100, 1.5+self.posizioneYtubi/100, -3.3);
		elseif self.ricercaMod < self.modPresenti
		then
			self:setStatoPA1(self.posizionePedana, self.posizioneTelo, self.tubiAssenti, self.posizioneXtubi, self.posizioneYtubi);
			self.isSprayerTank = false;
			if self.modMagica ~= nil
			then
				self.modMagica:setMenuMagicaAttivo(true);
			end;
		end;
		if self.attacherVehicle ~= nil
		then
			if self.attacherVehicle.motor.maxMotorPower == nil
			then
				self.posizioneTubo = self.posizioneBase;
			else
				if self.attacherVehicle.motor.maxMotorPower/1000 < 150
				then
					self.posizioneTubo = self.posizioneBase;
				elseif self.attacherVehicle.motor.maxMotorPower/1000 < 200
				then
					self.posizioneTubo = self.posizione150;
				else
					self.posizioneTubo = self.posizione200;
				end;
			end;
		end;
	end;
end;
function PA1:draw()
	if	   self.ricercaMod < self.modPresenti
	then
		g_currentMission:addExtraPrintText(g_i18n:getText('funzioni'));
	end;
end;
function PA1:drawMenuPA1Help(posY, param)
	if g_currentMission.inGameMessage:getIsVisible()
	then
		return;
	end;
	local posX = g_currentMission.helpBoxTextPos1X;
	local posX2 = g_currentMission.helpBoxTextPos2X;
	posY = posY - self.menuPA1HelpHeight;
	setTextBold(true);
	renderText(posX, posY + (self.menuPA1HelpHeight - g_currentMission.helpBoxTextSize) * 0.5, g_currentMission.helpBoxTextSize, g_i18n:getText("07PA1"));
	if self.tempoAttesa ~= 0
	then
		setTextColor(1, 0, 0, 1);
		renderText(posX2-self.menuPA1[1].statusBar.width*136/204, posY + (self.menuPA1HelpHeight - g_currentMission.helpBoxTextSize) * 0.5, g_currentMission.helpBoxTextSize, g_i18n:getText("33PA1"));
		setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
	end;
	setTextBold(false);
	local i = 0;
	for i, menuPA1 in pairs(self.menuPA1)
	do
		posY = posY - self.menuPA1HelpHeight;
		menuPA1.statusBar:setPosition(posX2 - menuPA1.statusBar.width, posY + (self.menuPA1HelpHeight - menuPA1.statusBar.height) * 0.5);
		menuPA1.statusBar:render();
		if i == self.menuSelezionato
		then
			overlaySelect = menuPA1.overlay;
		end;
		setTextAlignment(RenderText.ALIGN_LEFT);
		if	   self.menuSelezionato == i
		then
			setTextColor(1, 0, 0, 1);
		end;
		if	   i == self.menuPrimo
		then
			posYtitolo = posY + self.menuPA1TextOffsetY;
			renderText(posX, posY+self.menuPA1TextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("09PA1"));
		elseif i == self.menuSecondo
		then
			renderText(posX, posY+self.menuPA1TextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("10PA1"));
		elseif i == 6
		then
			posYoverlay = posY + (self.menuPA1HelpHeight - menuPA1.overlay.height) * 0.5;
		elseif i == 11
		then
			overlaySelect:setPosition(posX2-menuPA1.statusBar.width*200/204, posYoverlay);
			overlaySelect:render();
			setTextColor(1, 0, 0, 1);
			if	   self.menuSelezionato == self.menuPrimo
			then
				setTextBold(true);
				renderText(posX2-menuPA1.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("09PA1"));
				setTextBold(false);
				renderText(posX2-menuPA1.statusBar.width*200/204, posY+self.menuPA1TextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("11PA1")..string.format(self.posizioneYtubi/100+1.8));
			elseif self.menuSelezionato == self.menuSecondo
			then
				setTextBold(true);
				renderText(posX2-menuPA1.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("10PA1"));
				setTextBold(false);
				renderText(posX2-menuPA1.statusBar.width*200/204, posY+self.menuPA1TextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("12PA1")..string.format(self.posizioneXtubi/100+1.1));
			end;
			setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
		elseif i == 12
		then
			setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
			if	   self.menuSelezionato == self.menuPrimo
			then
				renderText(posX2-menuPA1.statusBar.width*200/204, posY+self.menuPA1TextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("13PA1"));
			elseif self.menuSelezionato == self.menuSecondo
			then
				renderText(posX2-menuPA1.statusBar.width*200/204, posY+self.menuPA1TextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("14PA1"));
			end;
		end;
		if	   self.menuSelezionato == i
		then
			setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
		end;
	end;
end;
function PA1:onAttach(attacherVehicle, jointDescIndex)
	self.attacherVehicle = attacherVehicle;
	self.ricercaMod = self.modAssenti;
	if self.attacherVehicle.motor.maxMotorPower == nil
	then
		self.posizioneTubo = self.posizioneBase;
	else
		if self.attacherVehicle.motor.maxMotorPower/1000 < 150
		then
			self.posizioneTubo = self.posizioneBase;
		elseif self.attacherVehicle.motor.maxMotorPower/1000 < 200
		then
			self.posizioneTubo = self.posizione150;
		else
			self.posizioneTubo = self.posizione200;
		end;
	end;
end;
function PA1:onDetach()
	self.attacherVehicle = nil;
	if self.posizioneTubi == self.tubiPresenti
	then
		self:setStatoPA1(self.posizionePedana, self.posizioneTelo, self.tubiAssenti, self.posizioneXtubi, self.posizioneYtubi);
	end;
	self.ricercaMod = self.modAssenti;
	self.posizioneXtubi = 0;
	self.posizioneYtubi = 0;
end;
function PA1:setStatoPA1(sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi, noEventSend)
	setStatoPA1Event.sendEvent(self, sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi, noEventSend);
	if	   sceltaPedana == self.pedanaAperta
	then
		self:playAnimation("pedana", 1, self:getAnimationTime("pedana"), true);
	elseif sceltaPedana == self.pedanaChiusa
	then
		self:playAnimation("pedana", -1, self:getAnimationTime("pedana"), true);
	end;
	if	   sceltaTubi == self.tubiPresenti
	then
		if	   self.posizioneTubo == self.posizioneBase
		then
			self:playAnimation("animazioneTubi", 1, self:getAnimationTime("animazioneTubi"), true);
		elseif self.posizioneTubo == self.posizione150
		then
			self:playAnimation("animazioneTubi150", 1, self:getAnimationTime("animazioneTubi150"), true);
		elseif self.posizioneTubo == self.posizione200
		then
			self:playAnimation("animazioneTubi200", 1, self:getAnimationTime("animazioneTubi200"), true);
		else
			self:playAnimation("animazioneTubi", 1, self:getAnimationTime("animazioneTubi"), true);		
		end;
	elseif sceltaTubi == self.tubiAssenti
	then
		if	   self.posizioneTubo == self.posizioneBase
		then
			self:playAnimation("animazioneTubi", -1, self:getAnimationTime("animazioneTubi"), true);
		elseif self.posizioneTubo == self.posizione150
		then
			self:playAnimation("animazioneTubi150", -1, self:getAnimationTime("animazioneTubi150"), true);
		elseif self.posizioneTubo == self.posizione200
		then
			self:playAnimation("animazioneTubi200", -1, self:getAnimationTime("animazioneTubi200"), true);
		else
			self:playAnimation("animazioneTubi", -1, self:getAnimationTime("animazioneTubi"), true);
		end;
	end;
	self.posizionePedana = sceltaPedana;
	self.posizioneTelo = sceltaTelo;
	self.posizioneTubi = sceltaTubi;
	self.posizioneXtubi = sceltaPosizioneXtubi;
	self.posizioneYtubi = sceltaPosizioneYtubi;
end;
setStatoPA1Event = {};
setStatoPA1Event_mt = Class(setStatoPA1Event, Event);
InitEventClass(setStatoPA1Event, "setStatoPA1Event");
function setStatoPA1Event:emptyNew()
	local self = Event:new(setStatoPA1Event_mt);
	self.className="setStatoPA1Event";
	return self;
end;
function setStatoPA1Event:new(object, sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi)
	local self = setStatoPA1Event:emptyNew();
	self.object = object;
	self.sceltaPedana = sceltaPedana;
	self.sceltaTelo = sceltaTelo;
	self.sceltaTubi = sceltaTubi;
	self.sceltaPosizioneXtubi = sceltaPosizioneXtubi;
	self.sceltaPosizioneYtubi = sceltaPosizioneYtubi;
	return self;
end;
function setStatoPA1Event:readStream(streamId, connection)
	self.object = readNetworkNodeObject(streamId);
	self.sceltaPedana = streamReadInt8(streamId);
	self.sceltaTelo = streamReadInt8(streamId);
	self.sceltaTubi = streamReadInt8(streamId);
	self.sceltaPosizioneXtubi = streamReadInt8(streamId);
	self.sceltaPosizioneYtubi = streamReadInt8(streamId);
	self:run(connection);
end;
function setStatoPA1Event:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.object);
	streamWriteInt8(streamId, self.sceltaPedana);
	streamWriteInt8(streamId, self.sceltaTelo);
	streamWriteInt8(streamId, self.sceltaTubi);
	streamWriteInt8(streamId, self.sceltaPosizioneXtubi);
	streamWriteInt8(streamId, self.sceltaPosizioneYtubi);
end;
function setStatoPA1Event:run(connection)
	if not connection:getIsServer()
	then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil
	then
		self.object:setStatoPA1(self.sceltaPedana, self.sceltaTelo, self.sceltaTubi, self.sceltaPosizioneXtubi, self.sceltaPosizioneYtubi, true);
	end;
end;
function setStatoPA1Event.sendEvent(vehicle, sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi, noEventSend)
	if noEventSend == nil
	or noEventSend == false
	then
		if g_server ~= nil
		then
			g_server:broadcastEvent(setStatoPA1Event:new(vehicle, sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(setStatoPA1Event:new(vehicle, sceltaPedana, sceltaTelo, sceltaTubi, sceltaPosizioneXtubi, sceltaPosizioneYtubi));
		end;
	end;
end;