--
-- magica
--
-- @author  DD ModPassion
-- @date  04/06/2017
--
-- Copyright (C) DD ModPassion, Confidential, All Rights Reserved.
magica = {};
AttacherJoints.registerJointType("tuboTrasporto");
function magica.prerequisitesPresent(specializations)
	return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;
function magica:preLoad(savegame)
	self.setStatoMagica = magica.setStatoMagica;
	self.setMenuMagicaAttivo = magica.setMenuMagicaAttivo;
	self.setEsclusioneCorpi = magica.setEsclusioneCorpi;
end;
function magica:load(savegame)
	self.magicaChiusa = 1;
	self.magicaAperta = 0;
	self.statoApertura = self.magicaChiusa;
	self.tempoAttesa = 0;
	self.corpiChiusi = 40;
	self.corpi45 = 45;
	self.corpi50 = 50;
	self.corpi60 = 60;
	self.corpi70 = 70;
	self.corpi75 = 75;
	self.corpi80 = 80;
	self.corpiCorrente = 80;
	self.profonditaCorpi = 1;
	self.workCollision = true;
	self.leveCodini = 1;
	self.selettoreCorpi = 1;
	self.selettoreMicroG = 1;
	self.coperchiSemiChiusi = 1;
	self.coperchiSemiAperti = 3;
	self.coperchiSemi = self.coperchiSemiChiusi;
	self.indexSemi = Utils.indexToObject(self.components, getXMLString(self.xmlFile,"vehicle.cover#indexSemi"));
	self.coperchiMicroGChiusi = 1;
	self.coperchiMicroGAperti = 3;
	self.coperchiMicroG = self.coperchiMicroGChiusi;
	self.indexMicro = Utils.indexToObject(self.components, getXMLString(self.xmlFile,"vehicle.cover#indexMicro"));
	self.rotazioneDiscoInterna = 1;
	self.rotazioneDiscoEsterna = 3;
	self.rotazioneDisco = self.rotazioneDiscoInterna;
	self.selezioneDiscoChiuso = 1;
	self.selezioneDiscoAperto = 3;
	self.selezioneDisco = self.selezioneDiscoAperto;
	self.tagliente = 1;
	self.spianaterra = 1;
	self.posizioneDisco = 1;
	self.larghezzaRuote120 = 120;
	self.larghezzaRuote130 = 130;
	self.larghezzaRuote140 = 140;
	self.larghezzaRuote150 = 150;
	self.larghezzaRuote160 = 160;
	self.larghezzaRuote170 = 170;
	self.larghezzaRuote180 = 180;
	self.larghezzaRuote190 = 190;
	self.larghezzaRuote = self.larghezzaRuote190;
	self.distanzaMod = 7;
	self.menuAttivo = 0;
	self.menuMagicaAttivo = true;
	self.menuPrimo = 1;
	self.menuSecondo = 2;
	self.menuTerzo = 3;
	self.menuQuarto = 4;
	self.menuQuinto = 5;
	self.menuSesto = 6;
	self.menuSettimo = 7;
	self.menuOttavo = 8;
	self.menuNono = 9;
	self.menuDecimo = 10;
	self.menuUndicesimo = 11;
	self.menuDodicesimo = 12;
	self.menuSelezionato = self.menuPrimo;
	self.cardano = {};
	self.cardano.startPtoRot = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#startPtoRot"));
	self.cardano.endPtoRot = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#endPtoRot"));
	self.cardano.tubi = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#tubi"));
	self.cardano.tubiIdraulici = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#tubiIdraulici"));
	self.cardano.tubiRotazione = {getRotation(self.cardano.tubi)};
	self.cardano.tubo = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#tubo"));
	self.cardano.tuboScale = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#tuboScale"));
	self.cardano.tuboTranslazione = {getTranslation(self.cardano.tubo)};
	self.cardano.referenceNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#referenceNode"));
	self.cardano.startPto = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.cardano#startPto"));
	self.cardano.startPtoTranslazione = {getTranslation(self.cardano.startPto)};
	self.cardano.startPtoRotazione = {getRotation(self.cardano.startPto)};
	self.cardano.rotazione = 0;
	self.cardano.ptoInput = nil;
	self.cardano.attached = false;
	self.tuboScale = 0;
	self.attacherVehicle = nil;
	self.fillLevel = 0;
	self.configuration_interfila = Utils.getFilename("image/configuration_interfila.dds", self.baseDirectory);
	self.configuration_altezzaCorpi = Utils.getFilename("image/configuration_altezzaCorpi.dds", self.baseDirectory);
	self.configuration_codini = Utils.getFilename("image/configuration_codini.dds", self.baseDirectory);
	self.configuration_selettoreSemi = Utils.getFilename("image/configuration_selettoreSemi.dds", self.baseDirectory);
	self.configuration_selettoreMicro = Utils.getFilename("image/configuration_selettoreMicro.dds", self.baseDirectory);
	self.configuration_coperchiSemi = Utils.getFilename("image/configuration_coperchiSemi.dds", self.baseDirectory);
	self.configuration_coperchiMicro = Utils.getFilename("image/configuration_coperchiMicro.dds", self.baseDirectory);
	self.configuration_ruotaDisco = Utils.getFilename("image/configuration_ruotaDisco.dds", self.baseDirectory);
	self.configuration_disco = Utils.getFilename("image/configuration_disco.dds", self.baseDirectory);
	self.configuration_tagliente = Utils.getFilename("image/configuration_tagliente.dds", self.baseDirectory);
	self.configuration_spianaterra = Utils.getFilename("image/configuration_spianaterra.dds", self.baseDirectory);
	self.configuration_spostaRuota = Utils.getFilename("image/configuration_spostaRuota.dds", self.baseDirectory);
	self.drawMenuMagicaHelp = SpecializationUtil.callSpecializationsFunction("drawMenuMagicaHelp");
	local uiScale = 1.0;
	if g_gameSettings ~= nil
	and g_gameSettings.getValue ~= nil
	then
		uiScale = Utils.getNoNil(g_gameSettings:getValue("uiScale"), 1.0);
	end;
	self.menuMagica = {};
	local i = 0;
	while true
	do
		local baseName = string.format("vehicle.menuMagica.impostazione(%d)", i);
		if not hasXMLProperty(self.xmlFile, baseName)
		then
			break;
		end;
		local entry = {};
		entry.name = {};
		local nome = getXMLString(self.xmlFile, baseName.."#name");
		entry.name[nome] = true;
		local width, height = getNormalizedScreenValues(200*uiScale, 200*uiScale);
		if	   i == 0
		then entry.overlay = Overlay:new("menu", self.configuration_interfila, 0, 0, width, height);
		elseif i == 1
		then entry.overlay = Overlay:new("menu", self.configuration_altezzaCorpi, 0, 0, width, height);
		elseif i == 2
		then entry.overlay = Overlay:new("menu", self.configuration_codini, 0, 0, width, height);
		elseif i == 3
		then entry.overlay = Overlay:new("menu", self.configuration_selettoreSemi, 0, 0, width, height);
		elseif i == 4
		then entry.overlay = Overlay:new("menu", self.configuration_selettoreMicro, 0, 0, width, height);
		elseif i == 5
		then entry.overlay = Overlay:new("menu", self.configuration_coperchiSemi, 0, 0, width, height);
		elseif i == 6
		then entry.overlay = Overlay:new("menu", self.configuration_coperchiMicro, 0, 0, width, height);
		elseif i == 7
		then entry.overlay = Overlay:new("menu", self.configuration_ruotaDisco, 0, 0, width, height);
		elseif i == 8
		then entry.overlay = Overlay:new("menu", self.configuration_disco, 0, 0, width, height);
		elseif i == 9
		then entry.overlay = Overlay:new("menu", self.configuration_tagliente, 0, 0, width, height);
		elseif i == 10
		then entry.overlay = Overlay:new("menu", self.configuration_spianaterra, 0, 0, width, height);
		elseif i == 11
		then entry.overlay = Overlay:new("menu", self.configuration_spostaRuota, 0, 0, width, height);
		end;
		entry.overlay:setColor(unpack(g_currentMission.helpBoxTextColor));
		if next(entry.name) ~= nil
		then
			entry.statusBarColor = {0.2122, 0.5271, 0.0307, 1};
			entry.statusBarColor2 = {0.2832, 0.0091, 0.0091, 1};
			local width, height = getNormalizedScreenValues(208*uiScale, 22*uiScale);
			entry.statusBar = StatusBar:new(g_baseUIFilename, g_colorBgUVs, nil, {0.0075, 0.0075, 0.0075, 1}, entry.statusBarColor2, nil, 0, 0, width, height);
			table.insert(self.menuMagica, entry);
		end;
		i = i + 1;
	end;
	self.menuMagicaTextOffsetX, self.menuMagicaTextOffsetY = getNormalizedScreenValues(28*uiScale, 7*uiScale);
	_, self.menuMagicaHelpHeight = getNormalizedScreenValues(0, 22*uiScale);
	_, self.menuMagicaHelpHeightOffset = getNormalizedScreenValues(0, 10*uiScale);
	self.isDetachAllowed = Utils.overwrittenFunction(self.isDetachAllowed, magica.isDetachAllowed);
	self.bloccoDistacco = true;
	self.esclusioneCorpo01 = false;
	self.esclusioneCorpo02 = false;
	self.esclusioneCorpo03 = false;
	self.esclusioneCorpo04 = false;
	self.esclusioneCorpo05 = false;
	self.esclusioneCorpo06 = false;
	self.esclusioneCorpo07 = false;
	self.esclusioneCorpo08 = false;
	self.camereAttive = false;
	self.numToolCameras = 7;
	self.numCameras = 0;
end;
function magica:postLoad(savegame)
	local statoApertura = self.statoApertura;
	local corpiCorrente = self.corpiCorrente;
	local profonditaCorpi = self.profonditaCorpi;
	local leveCodini = self.leveCodini;
	local selettoreCorpi = self.selettoreCorpi;
	local selettoreMicroG = self.selettoreMicroG;
	local rotazioneDisco = self.rotazioneDisco;
	local selezioneDisco = self.selezioneDisco;
	local tagliente = self.tagliente;
	local spianaterra = self.spianaterra;
	local posizioneDisco = self.posizioneDisco;
	local larghezzaRuote = self.larghezzaRuote;
	if savegame ~= nil
	and not savegame.resetVehicles
	then
		statoApertura = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#statoApertura"), self.statoApertura);
		corpiCorrente = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#corpiCorrente"), self.corpiCorrente);
		profonditaCorpi = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#profonditaCorpi"), self.profonditaCorpi);
		leveCodini = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#leveCodini"), self.leveCodini);
		selettoreCorpi = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#selettoreCorpi"), self.selettoreCorpi);
		selettoreMicroG = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#selettoreMicroG"), self.selettoreMicroG);
		rotazioneDisco = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#rotazioneDisco"), self.rotazioneDisco);
		selezioneDisco = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#selezioneDisco"), self.selezioneDisco);
		tagliente = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#tagliente"), self.tagliente);
		spianaterra = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#spianaterra"), self.spianaterra);
		posizioneDisco = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#posizioneDisco"), self.posizioneDisco);
		larghezzaRuote = Utils.getNoNil(getXMLInt(savegame.xmlFile, savegame.key .. "#larghezzaRuote"), self.larghezzaRuote);
	end;
	self:setStatoMagica(statoApertura, self.tempoAttesa, corpiCorrente, profonditaCorpi, leveCodini, selettoreCorpi, selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, rotazioneDisco, selezioneDisco, tagliente, spianaterra, posizioneDisco, larghezzaRuote, 0, true);
	local xmlFile = loadXMLFile("animazioniMagica", self.baseDirectory.."xmlFilename/animazioniMagica.xml");
	local i = table.getn(self.animations);
	while true
	do
		local key = string.format("vehicle.animations.animation(%d)", i);
		if not hasXMLProperty(xmlFile, key)
		then
			break;
		end;
		local name = getXMLString(xmlFile, key.."#name");
		if name ~= nil
		then
			local animation = {};
			animation.name = name;
			animation.parts = {};
			animation.currentTime = 0;
			animation.currentSpeed = 1;
			animation.looping = Utils.getNoNil(getXMLBool(xmlFile, key .. "#looping"), false);
			local partI = 0;
			while true
			do
				local partKey = key..string.format(".part(%d)", partI);
				if not hasXMLProperty(xmlFile, partKey)
				then
					break;
				end;
				local node = Utils.indexToObject(self.components, getXMLString(xmlFile, partKey.."#node"));
				local startTime = getXMLFloat(xmlFile, partKey.."#startTime");
				local duration = getXMLFloat(xmlFile, partKey.."#duration");
				local endTime = getXMLFloat(xmlFile, partKey.."#endTime");
				local direction = Utils.sign(Utils.getNoNil(getXMLInt(xmlFile, partKey.."#direction"), 0));
				local startRot = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#startRot"), 3);
				local endRot = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#endRot"), 3);
				local startTrans = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#startTrans"), 3);
				local endTrans = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#endTrans"), 3);
				local startScale = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#startScale"), 3);
				local endScale = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#endScale"), 3);
				local visibility = getXMLBool(xmlFile, partKey.."#visibility");
				local componentJointIndex = getXMLInt(xmlFile, partKey.."#componentJointIndex");
				local componentJoint;
				if componentJointIndex ~= nil
				then
					componentJoint = self.componentJoints[componentJointIndex+1];
				end;
				local startRotLimit = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#startRotLimit"), 3);
				local startRotMinLimit = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#startRotMinLimit"), 3);
				local startRotMaxLimit = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#startRotMaxLimit"), 3);
				if startRotLimit ~= nil
				then
					startRotMinLimit = {};
					startRotMaxLimit = {};
					for i=1,3
					do
						startRotMinLimit[i] = -startRotLimit[i];
						startRotMaxLimit[i] = startRotLimit[i];
					end;
				end;
				local endRotLimit = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#endRotLimit"), 3);
				local endRotMinLimit = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#endRotMinLimit"), 3);
				local endRotMaxLimit = Utils.getRadiansFromString(getXMLString(xmlFile, partKey.."#endRotMaxLimit"), 3);
				if endRotLimit ~= nil
				then
					endRotMinLimit = {};
					endRotMaxLimit = {};
					for i=1,3
					do
						endRotMinLimit[i] = -endRotLimit[i];
						endRotMaxLimit[i] = endRotLimit[i];
					end;
				end;
				local startTransLimit = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#startTransLimit"), 3);
				local startTransMinLimit = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#startTransMinLimit"), 3);
				local startTransMaxLimit = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#startTransMaxLimit"), 3);
				if startTransLimit ~= nil
				then
					startTransMinLimit = {};
					startTransMaxLimit = {};
					for i=1,3
					do
						startTransMinLimit[i] = -startTransLimit[i];
						startTransMaxLimit[i] = startTransLimit[i];
					end;
				end;
				local endTransLimit = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#endTransLimit"), 3);
				local endTransMinLimit = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#endTransMinLimit"), 3);
				local endTransMaxLimit = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#endTransMaxLimit"), 3);
				if endTransLimit ~= nil
				then
					endTransMinLimit = {};
					endTransMaxLimit = {};
					for i=1,3
					do
						endTransMinLimit[i] = -endTransLimit[i];
						endTransMaxLimit[i] = endTransLimit[i];
					end;
				end;
				local shaderParameter = getXMLString(xmlFile, partKey.."#shaderParameter");
				local shaderStartValues = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#shaderStartValues"), 4);
				local shaderEndValues = Utils.getVectorNFromString(getXMLString(xmlFile, partKey.."#shaderEndValues"), 4);
				if startTime ~= nil
				and (duration ~= nil or endTime ~= nil)
				and ( (node ~= nil and (endRot ~= nil or endTrans ~= nil or endScale ~= nil or visibility ~= nil))
				or (componentJoint ~= nil and ((endRotMinLimit ~= nil and endRotMaxLimit ~= nil)
				or (endTransMinLimit ~= nil and endTransMaxLimit ~= nil)))
				or (node ~= nil and shaderParameter ~= nil and (shaderStartValues ~= nil and shaderEndValues ~= nil)) )
				then
					if endTime ~= nil
					then
						duration = endTime - startTime;
					end;
					local part = {};
					part.node = node;
					part.startTime = startTime*1000;
					part.duration = duration*1000;
					part.direction = direction;
					if node ~= nil
					then
						if endRot ~= nil
						then
							part.startRot = startRot;
							part.endRot = endRot;
						end;
						if endTrans ~= nil
						then
							part.startTrans = startTrans;
							part.endTrans = endTrans;
						end;
						if endScale ~= nil
						then
							part.startScale = startScale;
							part.endScale = endScale;
						end;
						if shaderParameter ~= nil
						and shaderEndValues ~= nil
						and shaderStartValues ~= nil
						then
							part.shaderParameter = shaderParameter;
							part.shaderStartValues = shaderStartValues;
							part.shaderEndValues = shaderEndValues;
						end;
						part.visibility = visibility;
					end;
					if self.isServer
					then
						if componentJoint ~= nil
						then
							if endRotMinLimit ~= nil
							then
								part.componentJoint = componentJoint;
								part.startRotMinLimit = startRotMinLimit;
								part.startRotMaxLimit = startRotMaxLimit;
								part.endRotMinLimit = endRotMinLimit;
								part.endRotMaxLimit = endRotMaxLimit;
							end;
							if endTransMinLimit ~= nil
							then
								part.componentJoint = componentJoint;
								part.startTransMinLimit = startTransMinLimit;
								part.startTransMaxLimit = startTransMaxLimit;
								part.endTransMinLimit = endTransMinLimit;
								part.endTransMaxLimit = endTransMaxLimit;
							end;
						end;
					end;
					table.insert(animation.parts, part);
				end;
				partI = partI + 1;
			end;
			animation.partsReverse = {};
			for _, part in ipairs(animation.parts)
			do
				table.insert(animation.partsReverse, part);
			end;
			table.sort(animation.parts, AnimatedVehicle.animPartSorter);
			table.sort(animation.partsReverse, AnimatedVehicle.animPartSorterReverse);
			AnimatedVehicle.initializeParts(self, animation);
			animation.currentPartIndex = 1;
			animation.duration = 0;
			for _, part in ipairs(animation.parts)
			do
				animation.duration = math.max(animation.duration, part.startTime + part.duration);
			end;
			self.animations[name] = animation;
		end;
		i = i + 1;
	end;
end;
function magica:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'statoApertura="'..self.statoApertura..'" corpiCorrente="'..self.corpiCorrente..'" profonditaCorpi="'..self.profonditaCorpi..'" leveCodini="'..self.leveCodini..
	'" selettoreCorpi="'..self.selettoreCorpi..'" selettoreMicroG="'..self.selettoreMicroG..'" rotazioneDisco="'..self.rotazioneDisco..'" selezioneDisco="'..self.selezioneDisco..
	'" tagliente="'..self.tagliente..'" spianaterra="'..self.spianaterra..'" posizioneDisco="'..self.posizioneDisco..'" larghezzaRuote="'..self.larghezzaRuote..'"';
	return attributes, nil;
end;
function magica.readStream(self, streamId, connection)
	if connection:getIsServer()
	then
		local sceltaStatoApertura = streamReadInt8(streamId);
		local sceltaTempoAttesa = streamReadInt8(streamId);
		local sceltaCorpiCorrente = streamReadInt8(streamId);
		local sceltaProfonditaCorpi = streamReadInt8(streamId);
		local sceltaLeveCodini = streamReadInt8(streamId);
		local sceltaSelettoreCorpi = streamReadInt8(streamId);
		local sceltaSelettoreMicroG = streamReadInt8(streamId);
		local sceltaCoperchiSemi = streamReadInt8(streamId);
		local sceltaCoperchiMicroG = streamReadInt8(streamId);
		local sceltaRotazioneDisco = streamReadInt8(streamId);
		local sceltaSelezioneDisco = streamReadInt8(streamId);
		local sceltaTagliente = streamReadInt8(streamId);
		local sceltaSpianaterra = streamReadInt8(streamId);
		local sceltaPosizioneDisco = streamReadInt8(streamId);
		local sceltaLarghezzaRuote = streamReadInt8(streamId);
		local sceltaMenuAttivo = streamReadInt8(streamId);
		self:setStatoMagica(sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo, true);
		local sceltaMenuMagicaAttivo = streamReadBool(streamId);
		self:setMenuMagicaAttivo(sceltaMenuMagicaAttivo, true);
		local sceltaEsclusioneCorpo01 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo02 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo03 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo04 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo05 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo06 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo07 = streamReadBool(streamId);
		local sceltaEsclusioneCorpo08 = streamReadBool(streamId);
		self:setEsclusioneCorpi(sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08, true);
	end;
end;
function magica.writeStream(self, streamId, connection)
	if not connection:getIsServer()
	then
		streamWriteInt8(streamId, self.statoApertura);
		streamWriteInt8(streamId, self.tempoAttesa);
		streamWriteInt8(streamId, self.corpiCorrente);
		streamWriteInt8(streamId, self.profonditaCorpi);
		streamWriteInt8(streamId, self.leveCodini);
		streamWriteInt8(streamId, self.selettoreCorpi);
		streamWriteInt8(streamId, self.selettoreMicroG);
		streamWriteInt8(streamId, self.coperchiSemi);
		streamWriteInt8(streamId, self.coperchiMicroG);
		streamWriteInt8(streamId, self.rotazioneDisco);
		streamWriteInt8(streamId, self.selezioneDisco);
		streamWriteInt8(streamId, self.tagliente);
		streamWriteInt8(streamId, self.spianaterra);
		streamWriteInt8(streamId, self.posizioneDisco);
		streamWriteInt8(streamId, self.larghezzaRuote);
		streamWriteInt8(streamId, self.menuAttivo);
		streamWriteBool(streamId, self.menuMagicaAttivo);
		streamWriteBool(streamId, self.esclusioneCorpo01);
		streamWriteBool(streamId, self.esclusioneCorpo02);
		streamWriteBool(streamId, self.esclusioneCorpo03);
		streamWriteBool(streamId, self.esclusioneCorpo04);
		streamWriteBool(streamId, self.esclusioneCorpo05);
		streamWriteBool(streamId, self.esclusioneCorpo06);
		streamWriteBool(streamId, self.esclusioneCorpo07);
		streamWriteBool(streamId, self.esclusioneCorpo08);
	end;
end;
function magica:delete()
end;
function magica:mouseEvent(posX, posY, isDown, isUp, button)
end;
function magica:keyEvent(unicode, sym, modifier, isDown)
end;
function magica:update(dt)
	if self:getIsActive()
	and self.isClient
	then
		self:playAnimation("ruotaTrattoreOff", 1, 0, true);
		if self:getIsActiveForInput(true)
		and self.attacherVehicle ~= nil
		and InputBinding.hasEvent(InputBinding.Magica_letteraK)
		then
			if g_server == nil
			then
				self.numCameras = table.getn(self.attacherVehicle.cameras);
				if not self.camereAttive
				then
					self.attacherVehicle.numCameras = self.numCameras - self.numToolCameras;
				else
					self.attacherVehicle.numCameras = self.numCameras;
				end;
			else
				self.camereAttive = not self.camereAttive;
			end;
		end;
	end;
	if g_currentMission.player ~= nil
	and g_currentMission.player.isEntered
	then
		local gx, gy, gz = getWorldTranslation(g_currentMission.player.rootNode);
		local mx, my, mz = getWorldTranslation(self.components[1].node);
		if Utils.vector3Length(gx-mx, gy-my, gz-mz) < self.distanzaMod
		and self.menuMagicaAttivo == true
		and self.menuAttivo > 0
		then
			local helpHeight = (self.menuDodicesimo+1)*self.menuMagicaHelpHeight + self.menuMagicaHelpHeightOffset;
			g_currentMission:addHelpTextFunction(self.drawMenuMagicaHelp, self, helpHeight, nil);
			if self.tempoAttesa == 0
			then
				g_currentMission:addHelpButtonText(g_i18n:getText("05magica"), InputBinding.Magica_paginaSu, nil, GS_PRIO_HIGH);
				if InputBinding.hasEvent(InputBinding.Magica_paginaSu)
				then
					self.menuSelezionato = self.menuSelezionato - 1;
					if self.menuSelezionato < self.menuPrimo
					then
						self.menuSelezionato = self.menuDodicesimo;
					end;
				end;
				g_currentMission:addHelpButtonText(g_i18n:getText("04magica"), InputBinding.Magica_paginaGiù, nil, GS_PRIO_HIGH);
				if InputBinding.hasEvent(InputBinding.Magica_paginaGiù)
				then
					self.menuSelezionato = self.menuSelezionato + 1;
					if self.menuSelezionato > self.menuDodicesimo
					then
						self.menuSelezionato = self.menuPrimo;
					end;
				end;
				if self.menuSelezionato == self.menuPrimo
				then
					if	   self.statoApertura ~= self.magicaChiusa
					then
						g_currentMission:addExtraPrintText(g_i18n:getText("20magica"));
					elseif self.statoApertura == self.magicaChiusa
					then
						if self.corpiCorrente < 80
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
							if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
							then
								if	   self.corpiCorrente == self.corpi45
								then
									self.corpiCorrente = self.corpi50;
								elseif self.corpiCorrente == self.corpi50
								then
									self.corpiCorrente = self.corpi60;
								elseif self.corpiCorrente == self.corpi60
								then
									self.corpiCorrente = self.corpi70;
								elseif self.corpiCorrente == self.corpi70
								then
									self.corpiCorrente = self.corpi75;
								elseif self.corpiCorrente == self.corpi75
								then
									self.corpiCorrente = self.corpi80;
								end;
								self.menuAttivo = 1;
								self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
							end;
						end;
						if self.corpiCorrente > 45
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
							if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
							then
								if	   self.corpiCorrente == self.corpi50
								then
									self.corpiCorrente = self.corpi45;
								elseif self.corpiCorrente == self.corpi60
								then
									self.corpiCorrente = self.corpi50;
								elseif self.corpiCorrente == self.corpi70
								then
									self.corpiCorrente = self.corpi60;
								elseif self.corpiCorrente == self.corpi75
								then
									self.corpiCorrente = self.corpi70;
								elseif self.corpiCorrente == self.corpi80
								then
									self.corpiCorrente = self.corpi75;
								end;
								self.menuAttivo = 1;
								self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
							end;
						end;
					end;
				elseif self.menuSelezionato == self.menuSecondo
				then
					if self.profonditaCorpi < 13
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 3;
							self.profonditaCorpi = self.profonditaCorpi + 1;
							self.menuAttivo = 2;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.profonditaCorpi > 1
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 3;
							self.profonditaCorpi = self.profonditaCorpi - 1;
							self.menuAttivo = 2;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuTerzo
				then
					if self.leveCodini < 7
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 1.2;
							self.leveCodini = self.leveCodini + 1;
							self.menuAttivo = 3;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.leveCodini > 1
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 1.2;
							self.leveCodini = self.leveCodini - 1;
							self.menuAttivo = 3;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuQuarto
				then
					if self.selettoreCorpi < 12
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 0.1;
							self.selettoreCorpi = self.selettoreCorpi + 1;
							self.menuAttivo = 4;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.selettoreCorpi > 1
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 0.1;
							self.selettoreCorpi = self.selettoreCorpi - 1;
							self.menuAttivo = 4;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuQuinto
				then
					if self.selettoreMicroG < 10
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 1.8;
							self.selettoreMicroG = self.selettoreMicroG + 1;
							self.menuAttivo = 5;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.selettoreMicroG > 1
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 1.8;
							self.selettoreMicroG = self.selettoreMicroG - 1;
							self.menuAttivo = 5;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuSesto
				then
					local x, _, _ = getRotation(self.indexSemi);
					if x > 0
					then
						self.coperchiSemi = self.coperchiSemiAperti;
						self:setAnimationTime("coperchiSemi", 1);
					else
						self.coperchiSemi = self.coperchiSemiChiusi;
						self:setAnimationTime("coperchiSemi", 0);
					end;
					if	   self.coperchiSemi == self.coperchiSemiAperti
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("13magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 1;
							self.coperchiSemi = self.coperchiSemiChiusi;
							self.menuAttivo = 6;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					elseif self.coperchiSemi == self.coperchiSemiChiusi
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("12magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 1;
							self.coperchiSemi = self.coperchiSemiAperti;
							self.menuAttivo = 6;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuSettimo
				then
					local x, _, _ = getRotation(self.indexMicro);
					if x > 0
					then
						self.coperchiMicroG = self.coperchiMicroGAperti;
						self:setAnimationTime("coperchiMicroG", 1);
					else
						self.coperchiMicroG = self.coperchiMicroGChiusi;
						self:setAnimationTime("coperchiMicroG", 0);
					end;
					if	   self.coperchiMicroG == self.coperchiMicroGChiusi
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("12magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 1;
							self.coperchiMicroG = self.coperchiMicroGAperti;
							self.menuAttivo = 7;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					elseif self.coperchiMicroG == self.coperchiMicroGAperti
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("13magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 1;
							self.coperchiMicroG = self.coperchiMicroGChiusi;
							self.menuAttivo = 7;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuOttavo
				then
					if	   self.rotazioneDisco == self.rotazioneDiscoEsterna
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("14magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.rotazioneDisco = self.rotazioneDiscoInterna;
							self.menuAttivo = 8;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					elseif self.rotazioneDisco == self.rotazioneDiscoInterna
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("15magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.rotazioneDisco = self.rotazioneDiscoEsterna;
							self.menuAttivo = 8;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuNono
				then
					if	   self.selezioneDisco == self.selezioneDiscoChiuso
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("16magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.selezioneDisco = self.selezioneDiscoAperto;
							self.menuAttivo = 9;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					elseif self.selezioneDisco == self.selezioneDiscoAperto
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("17magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.selezioneDisco = self.selezioneDiscoChiuso;
							self.menuAttivo = 9;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuDecimo
				then
					if self.tagliente < 18
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 0.7;
							self.tagliente = self.tagliente + 1;
							self.menuAttivo = 10;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.tagliente > 1
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 0.7;
							self.tagliente = self.tagliente - 1;
							self.menuAttivo = 10;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuUndicesimo
				then
					if self.spianaterra < 18
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("02magica"), InputBinding.Magica_numpadPiù);
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							self.tempoAttesa = 0.7;
							self.spianaterra = self.spianaterra + 1;
							self.menuAttivo = 11;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.spianaterra > 1
					then
						g_currentMission:addHelpButtonText(g_i18n:getText("03magica"), InputBinding.Magica_numpadMeno);
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.tempoAttesa = 0.7;
							self.spianaterra = self.spianaterra - 1;
							self.menuAttivo = 11;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				elseif self.menuSelezionato == self.menuDodicesimo
				then
					self:playAnimation("ruotaTrattoreOn", 1, 0, true);
					if self.larghezzaRuote < 190
					then
						if self.larghezzaRuote == 0
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("22magica"), InputBinding.Magica_numpadPiù);
						end;
						if InputBinding.hasEvent(InputBinding.Magica_numpadPiù)
						then
							if self.larghezzaRuote < 120
							then
								self.larghezzaRuote = 110;
							else
								g_currentMission:addHelpButtonText(g_i18n:getText("31magica")..string.format((self.larghezzaRuote+10)/100).." "..g_i18n:getText("unit_miles"), InputBinding.Magica_numpadMeno);
							end;
							self.larghezzaRuote = self.larghezzaRuote + 10;
							self.posizioneDisco = 2;
							self.menuAttivo = 12;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
					if self.larghezzaRuote > 0
					then
						if self.larghezzaRuote == 120
						then
							g_currentMission:addHelpButtonText(g_i18n:getText("21magica"), InputBinding.Magica_numpadMeno);
						else
							g_currentMission:addHelpButtonText(g_i18n:getText("31magica")..string.format((self.larghezzaRuote-10)/100).." "..g_i18n:getText("unit_miles"), InputBinding.Magica_numpadMeno);
						end;
						if InputBinding.hasEvent(InputBinding.Magica_numpadMeno)
						then
							self.larghezzaRuote = self.larghezzaRuote - 10;
							self.posizioneDisco = 2;
							if self.larghezzaRuote < 120
							then
								self.posizioneDisco = 1;
								self.larghezzaRuote = 0;
							end;
							self.menuAttivo = 12;
							self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
						end;
					end;
				end;
				if self.menuSelezionato == self.menuDodicesimo
				then
					self:playAnimation("ruotaTrattoreOn", 1, 0, true);
				else
					self:playAnimation("ruotaTrattoreOff", 1, 0, true);
				end;
			end;
		else
			self:playAnimation("ruotaTrattoreOff", 1, 0, true);
		end;
	end;
	if self.isClient
	then
		if self.tempoAttesa > 0
		then
			self.tempoAttesa = self.tempoAttesa - (dt/1000);
		else
			self.tempoAttesa = 0;
		end;
		if self:isLowered()
		and self.workCollision
		then
			self.bloccoDistacco = false;
			self:playAnimation("workCollision", 10, self:getAnimationTime("workCollision"), true);
			if	   self.profonditaCorpi == 1
			then
				self:playAnimation("01workCollision", 10, self:getAnimationTime("01workCollision"), true);
			elseif self.profonditaCorpi == 2
			then
				self:playAnimation("02workCollision", 10, self:getAnimationTime("02workCollision"), true);
			elseif self.profonditaCorpi == 3
			then
				self:playAnimation("03workCollision", 10, self:getAnimationTime("03workCollision"), true);
			elseif self.profonditaCorpi == 4
			then
				self:playAnimation("04workCollision", 10, self:getAnimationTime("04workCollision"), true);
			elseif self.profonditaCorpi == 5
			then
				self:playAnimation("05workCollision", 10, self:getAnimationTime("05workCollision"), true);
			elseif self.profonditaCorpi == 6
			then
				self:playAnimation("06workCollision", 10, self:getAnimationTime("06workCollision"), true);
			elseif self.profonditaCorpi == 7
			then
				self:playAnimation("07workCollision", 10, self:getAnimationTime("07workCollision"), true);
			elseif self.profonditaCorpi == 8
			then
				self:playAnimation("08workCollision", 10, self:getAnimationTime("08workCollision"), true);
			elseif self.profonditaCorpi == 9
			then
				self:playAnimation("09workCollision", 10, self:getAnimationTime("09workCollision"), true);
			elseif self.profonditaCorpi == 10
			then
				self:playAnimation("10workCollision", 10, self:getAnimationTime("10workCollision"), true);
			elseif self.profonditaCorpi == 11
			then
				self:playAnimation("11workCollision", 10, self:getAnimationTime("11workCollision"), true);
			elseif self.profonditaCorpi == 12
			then
				self:playAnimation("12workCollision", 10, self:getAnimationTime("12workCollision"), true);
			elseif self.profonditaCorpi == 13
			then
				self:playAnimation("13workCollision", 10, self:getAnimationTime("13workCollision"), true);
			end;
		elseif not self:isLowered()
		then
			self.bloccoDistacco = true;
			self.workCollision = true;
		end;
		if self:getLastSpeed() > 2
		and self:isLowered()
		then
			self.workCollision = false;
			self:playAnimation("workCollision", -1, self:getAnimationTime("workCollision"), true);
			if	   self.profonditaCorpi == 1
			then
				self:playAnimation("01workCollision", -1, self:getAnimationTime("01workCollision"), true);
			elseif self.profonditaCorpi == 2
			then
				self:playAnimation("02workCollision", -1, self:getAnimationTime("02workCollision"), true);
			elseif self.profonditaCorpi == 3
			then
				self:playAnimation("03workCollision", -1, self:getAnimationTime("03workCollision"), true);
			elseif self.profonditaCorpi == 4
			then
				self:playAnimation("04workCollision", -1, self:getAnimationTime("04workCollision"), true);
			elseif self.profonditaCorpi == 5
			then
				self:playAnimation("05workCollision", -1, self:getAnimationTime("05workCollision"), true);
			elseif self.profonditaCorpi == 6
			then
				self:playAnimation("06workCollision", -1, self:getAnimationTime("06workCollision"), true);
			elseif self.profonditaCorpi == 7
			then
				self:playAnimation("07workCollision", -1, self:getAnimationTime("07workCollision"), true);
			elseif self.profonditaCorpi == 8
			then
				self:playAnimation("08workCollision", -1, self:getAnimationTime("08workCollision"), true);
			elseif self.profonditaCorpi == 9
			then
				self:playAnimation("09workCollision", -1, self:getAnimationTime("09workCollision"), true);
			elseif self.profonditaCorpi == 10
			then
				self:playAnimation("10workCollision", -1, self:getAnimationTime("10workCollision"), true);
			elseif self.profonditaCorpi == 11
			then
				self:playAnimation("11workCollision", -1, self:getAnimationTime("11workCollision"), true);
			elseif self.profonditaCorpi == 12
			then
				self:playAnimation("12workCollision", -1, self:getAnimationTime("12workCollision"), true);
			elseif self.profonditaCorpi == 13
			then
				self:playAnimation("13workCollision", -1, self:getAnimationTime("13workCollision"), true);
			end;
		end;
		if self.attacherVehicle ~= nil
		and self.isClient
		and self.cardano.ptoInput ~= nil
		then
			if self:getIsTurnedOn()
			then
				self.cardano.rotazione = (self.cardano.rotazione+dt*0.01) % (2*math.pi);
				setRotation(self.cardano.startPtoRot, 0, 0, self.cardano.rotazione);
				setRotation(self.cardano.endPtoRot, 0, 0, self.cardano.rotazione);
			end;
			setTranslation(self.cardano.startPto, 0, 0, 0);
			local ptoInputX, ptoInputY, ptoInputZ = getWorldTranslation(self.cardano.ptoInput);
			local startPtoX, startPtoY, startPtoZ = worldToLocal(self.cardano.startPto, ptoInputX, ptoInputY, ptoInputZ);
			setTranslation(self.cardano.startPto, startPtoX, startPtoY, startPtoZ);
			setTranslation(self.cardano.tubiIdraulici, startPtoX-0.375, startPtoY+0.15, startPtoZ+0.65);
			setDirection(self.cardano.tubi, startPtoX, startPtoY, startPtoZ-0.2, 0, 1, 0);
			local _,_,distanza = worldToLocal(self.cardano.tubi, ptoInputX, ptoInputY, ptoInputZ);
			if self.tuboScale < distanza+0.274
			then
				self.tuboScale = distanza+0.274;
			end;
			setScale(self.cardano.tuboScale, 1, 1, self.tuboScale)
			local tuboX, tuboY, tuboZ = unpack(self.cardano.tuboTranslazione);
			setTranslation(self.cardano.tubo, tuboX, tuboY, tuboZ+distanza-0.726);
		end;
	end;
end;
function magica:updateTick(dt)
	if self.isClient
	then
		if self.attacherVehicle ~= nil
		and self.attacherVehicle.cameras ~= nil
		then
			self.numCameras = table.getn(self.attacherVehicle.cameras);
			if not self.camereAttive
			then
				self.attacherVehicle.numCameras = self.numCameras - self.numToolCameras;
			else
				self.attacherVehicle.numCameras = self.numCameras;
			end;
		end;
		self.fillLevel = math.min(self.fillUnits[1].fillLevel, self.fillUnits[2].fillLevel);
		self:setUnitFillLevel(3, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(4, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(5, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(6, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(7, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(8, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(9, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(10, self.fillUnits[1].fillLevel/80, FillUtil.FILLTYPE_SEEDS, true);
		self:setUnitFillLevel(11, self.fillUnits[2].fillLevel/40, FillUtil.FILLTYPE_FERTILIZER, true);
		self:setUnitFillLevel(12, self.fillUnits[2].fillLevel/40, FillUtil.FILLTYPE_FERTILIZER, true);
		self:setUnitFillLevel(13, self.fillUnits[2].fillLevel/40, FillUtil.FILLTYPE_FERTILIZER, true);
		self:setUnitFillLevel(14, self.fillUnits[2].fillLevel/40, FillUtil.FILLTYPE_FERTILIZER, true);
		if	  self.foldAnimTime == 1
		and self.statoApertura == self.magicaAperta
		then
			self.statoApertura = self.magicaChiusa;
			self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
		elseif self.foldAnimTime < 1
		and self.statoApertura == self.magicaChiusa
		then
			self.statoApertura = self.magicaAperta;
			self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
		end;
		if self.menuAttivo == 0
		and self.menuMagicaAttivo
		then
			if self.foldAnimTime < 1
			then
				self:onAiTurnOn()
			end;
			self:setStatoMagica(self.statoApertura, self.tempoAttesa, self.corpiCorrente, self.profonditaCorpi, self.leveCodini, self.selettoreCorpi, self.selettoreMicroG, self.coperchiSemi, self.coperchiMicroG, self.rotazioneDisco, self.selezioneDisco, self.tagliente, self.spianaterra, self.posizioneDisco, self.larghezzaRuote, self.menuAttivo);
			self.menuAttivo = 1;
		end;
	end;
end;
function magica:draw()
	g_currentMission:addExtraPrintText(g_i18n:getText('funzioni'));
end;
function magica:drawMenuMagicaHelp(posY, param)
	if g_currentMission.inGameMessage:getIsVisible()
	then
		return;
	end;
	local posX = g_currentMission.helpBoxTextPos1X;
	local posX2 = g_currentMission.helpBoxTextPos2X;
	posY = posY - self.menuMagicaHelpHeight;
	setTextBold(true);
	renderText(posX, posY + (self.menuMagicaHelpHeight - g_currentMission.helpBoxTextSize) * 0.5, g_currentMission.helpBoxTextSize, g_i18n:getText("34magica"));
	if self.tempoAttesa ~= 0
	then
		setTextColor(1, 0, 0, 1);
		renderText(posX2-self.menuMagica[1].statusBar.width*136/204, posY + (self.menuMagicaHelpHeight - g_currentMission.helpBoxTextSize) * 0.5, g_currentMission.helpBoxTextSize, g_i18n:getText("33magica"));
		setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
	end;
	setTextBold(false);
	local i = 0;
	for i, menuMagica in pairs(self.menuMagica)
	do
		posY = posY - self.menuMagicaHelpHeight;
		menuMagica.statusBar:setPosition(posX2 - menuMagica.statusBar.width, posY + (self.menuMagicaHelpHeight - menuMagica.statusBar.height) * 0.5);
		menuMagica.statusBar:render();
		if i == self.menuSelezionato
		then
			overlaySelect = menuMagica.overlay;
		end;
		setTextAlignment(RenderText.ALIGN_LEFT);
		if	   self.menuSelezionato == i
		then
			setTextColor(1, 0, 0, 1);
		end;
		if	   i == self.menuPrimo
		then
			posYtitolo = posY + self.menuMagicaTextOffsetY;
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("distanzaFile"));
		elseif i == self.menuSecondo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("altezzaCorpi"));
		elseif i == self.menuTerzo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("regolazioneCodini"));
		elseif i == self.menuQuarto
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("selettoreSemi"));
		elseif i == self.menuQuinto
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("selettoreMicroG"));
		elseif i == self.menuSesto
		then
			posYoverlay = posY + (self.menuMagicaHelpHeight - menuMagica.overlay.height) * 0.5;
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("coperchiSemi"));
		elseif i == self.menuSettimo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("coperchiMicroG"));
		elseif i == self.menuOttavo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("rotazioneDisco"));
		elseif i == self.menuNono
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("selezioneDisco"));
		elseif i == self.menuDecimo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("tagliente"));
		elseif i == self.menuUndicesimo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("spianaterra"));
			overlaySelect:setPosition(posX2-menuMagica.statusBar.width*200/204, posYoverlay);
			overlaySelect:render();
			setTextColor(1, 0, 0, 1);
			if	   self.menuSelezionato == self.menuPrimo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("distanzaFile"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("01magica")..string.format(self.corpiCorrente));
			elseif self.menuSelezionato == self.menuSecondo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("altezzaCorpi"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("06magica")..string.format(self.profonditaCorpi));
			elseif self.menuSelezionato == self.menuTerzo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("regolazioneCodini"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("09magica")..string.format(self.leveCodini));
			elseif self.menuSelezionato == self.menuQuarto
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("selettoreSemi"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("10magica")..string.format(self.selettoreCorpi));
			elseif self.menuSelezionato == self.menuQuinto
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("selettoreMicroG"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("11magica")..string.format(self.selettoreMicroG-1));
			elseif self.menuSelezionato == self.menuSesto
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("coperchiSemi"));
				setTextBold(false);
				if	   self.coperchiSemi == self.coperchiSemiAperti
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("12magica"));
				elseif self.coperchiSemi == self.coperchiSemiChiusi
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("13magica"));
				end;
			elseif self.menuSelezionato == self.menuSettimo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("coperchiMicroG"));
				setTextBold(false);
				if	   self.coperchiMicroG == self.coperchiMicroGAperti
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("12magica"));
				elseif self.coperchiMicroG == self.coperchiMicroGChiusi
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("13magica"));
				end;
			elseif self.menuSelezionato == self.menuOttavo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("rotazioneDisco"));
				setTextBold(false);
				if	   self.rotazioneDisco == self.rotazioneDiscoInterna
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("14magica"));
				elseif self.rotazioneDisco == self.rotazioneDiscoEsterna
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("15magica"));
				end;
			elseif self.menuSelezionato == self.menuNono
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("selezioneDisco"));
				setTextBold(false);
				if	   self.selezioneDisco == self.selezioneDiscoChiuso
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("17magica"));
				elseif self.selezioneDisco == self.selezioneDiscoAperto
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("16magica"));
				end;
			elseif self.menuSelezionato == self.menuDecimo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("tagliente"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("18magica")..string.format(self.tagliente));
			elseif self.menuSelezionato == self.menuUndicesimo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("spianaterra"));
				setTextBold(false);
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("19magica")..string.format(self.spianaterra));
			elseif self.menuSelezionato == self.menuDodicesimo
			then
				setTextBold(true);
				renderText(posX2-menuMagica.statusBar.width*200/204, posYtitolo, g_currentMission.helpBoxTextSize, g_i18n:getText("posizioneDisco"));
				setTextBold(false);
				if	   self.posizioneDisco == 1
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("21magica"));
				elseif self.posizioneDisco == 2
				then
					renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("35magica")..g_i18n:getText("31magica")..string.format(self.larghezzaRuote/100).." "..g_i18n:getText("unit_miles"));
				end;
			end;
			setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
		elseif i == self.menuDodicesimo
		then
			renderText(posX, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("posizioneDisco"));
			setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
			if	   self.menuSelezionato == self.menuPrimo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("36magica"));
			elseif self.menuSelezionato == self.menuSecondo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("37magica"));
			elseif self.menuSelezionato == self.menuTerzo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("38magica"));
			elseif self.menuSelezionato == self.menuQuarto
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("39magica"));
			elseif self.menuSelezionato == self.menuQuinto
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("40magica"));
			elseif self.menuSelezionato == self.menuSesto
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("41magica"));
			elseif self.menuSelezionato == self.menuSettimo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("42magica"));
			elseif self.menuSelezionato == self.menuOttavo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("43magica"));
			elseif self.menuSelezionato == self.menuNono
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("44magica"));
			elseif self.menuSelezionato == self.menuDecimo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("45magica"));
			elseif self.menuSelezionato == self.menuUndicesimo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("46magica"));
			elseif self.menuSelezionato == self.menuDodicesimo
			then
				renderText(posX2-menuMagica.statusBar.width*200/204, posY+self.menuMagicaTextOffsetY, g_currentMission.helpBoxTextSize, g_i18n:getText("47magica"));
			end;
		end;
		if	   self.menuSelezionato == i
		then
			setTextColor(g_currentMission.helpBoxTextColor[1], g_currentMission.helpBoxTextColor[2], g_currentMission.helpBoxTextColor[3], g_currentMission.helpBoxTextColor[4]);
		end;
	end;
end;
function magica:onAttach(attacherVehicle, jointDescIndex)
	local attachedJoints = attacherVehicle.attacherJoints[jointDescIndex];
	self.cardano.ptoInput = attachedJoints.ptoOutput.node;
	self.attacherVehicle = attacherVehicle;
	self.tuboScale = 0;
	self.camereAttive = false;
	if g_server == nil
	then
		self.numCameras = table.getn(self.attacherVehicle.cameras);
		if not self.camereAttive
		then
			self.attacherVehicle.numCameras = self.numCameras - self.numToolCameras;
		else
			self.attacherVehicle.numCameras = self.numCameras;
		end;
	end;
end;
function magica:onDetach()
	self.cardano.ptoInput = nil;
	self.workCollision = true;
	setTranslation(self.cardano.startPto, unpack(self.cardano.startPtoTranslazione));
	setRotation(self.cardano.startPto, unpack(self.cardano.startPtoRotazione));
	setTranslation(self.cardano.tubo, unpack(self.cardano.tuboTranslazione));
	setRotation(self.cardano.tubi, unpack(self.cardano.tubiRotazione));
	self:playAnimation("workCollision", 10, self:getAnimationTime("workCollision"), true);
	if self.attacherVehicle ~= nil
	then
		self.attacherVehicle.numCameras = self.numCameras;
	end;
end;
function magica:isDetachAllowed(superFunc)
	if self.bloccoDistacco
	then
		return false;
	end;
	if superFunc ~= nil
	then
		return superFunc(self);
	end;
	return true;
end;
function magica:setStatoMagica(sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo, noEventSend)
	setStatoMagicaEvent.sendEvent(self, sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo, noEventSend);
	if sceltaMenuAttivo == self.menuPrimo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaCorpiCorrente == 45
		then
			self:playAnimation("45barreInterfila", 1, 0, true);
		elseif sceltaCorpiCorrente == 50
		then
			self:playAnimation("50barreInterfila", 1, 0, true);
		elseif sceltaCorpiCorrente == 60
		then
			self:playAnimation("60barreInterfila", 1, 0, true);
		elseif sceltaCorpiCorrente == 70
		then
			self:playAnimation("70barreInterfila", 1, 0, true);
		elseif sceltaCorpiCorrente == 75
		then
			self:playAnimation("75barreInterfila", 1, 0, true);
		elseif sceltaCorpiCorrente == 80
		then
			self:playAnimation("80barreInterfila", 1, 0, true);
		end;
		local i = 0;
		for i,foldingPart in pairs(self.foldingParts)
		do
			if	   sceltaCorpiCorrente == self.corpi45
			and i == 1
			then
				foldingPart.animationName = "animazioneCorpi45";
			elseif sceltaCorpiCorrente == self.corpi50
			and i == 2
			then
				foldingPart.animationName = "animazioneCorpi50";
			elseif sceltaCorpiCorrente == self.corpi60
			and i == 3
			then
				foldingPart.animationName = "animazioneCorpi60";
			elseif sceltaCorpiCorrente == self.corpi70
			and i == 4
			then
				foldingPart.animationName = "animazioneCorpi70";
			elseif sceltaCorpiCorrente == self.corpi75
			and i == 5
			then
				foldingPart.animationName = "animazioneCorpi75";
			elseif sceltaCorpiCorrente == self.corpi80
			and i == 6
			then
				foldingPart.animationName = "animazioneCorpi80";
			else
				foldingPart.animationName = "animazioneCorpi";
			end;
		end;
	end;
	if sceltaMenuAttivo == self.menuPrimo
	or sceltaMenuAttivo == self.menuDodicesimo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaCorpiCorrente == 45
		then
			if sceltaPosizioneDisco == 1
			then
				self:playAnimation("45cDiscoSegnafila", 1, 0, true);
			else
				if	   sceltaLarghezzaRuote == 120
				then
					self:playAnimation("45r120DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 130
				then
					self:playAnimation("45r130DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 140
				then
					self:playAnimation("45r140DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 150
				then
					self:playAnimation("45r150DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 160
				then
					self:playAnimation("45r160DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 170
				then
					self:playAnimation("45r170DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 180
				then
					self:playAnimation("45r180DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 190
				then
					self:playAnimation("45r190DiscoSegnafila", 1, 0, true);
				end;
			end;
		elseif sceltaCorpiCorrente == 50
		then
			if sceltaPosizioneDisco == 1
			then
				self:playAnimation("50cDiscoSegnafila", 1, 0, true);
			else
				if	   sceltaLarghezzaRuote == 120
				then
					self:playAnimation("50r120DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 130
				then
					self:playAnimation("50r130DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 140
				then
					self:playAnimation("50r140DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 150
				then
					self:playAnimation("50r150DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 160
				then
					self:playAnimation("50r160DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 170
				then
					self:playAnimation("50r170DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 180
				then
					self:playAnimation("50r180DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 190
				then
					self:playAnimation("50r190DiscoSegnafila", 1, 0, true);
				end;
			end;
		elseif sceltaCorpiCorrente == 60
		then
			if sceltaPosizioneDisco == 1
			then
				self:playAnimation("60cDiscoSegnafila", 1, 0, true);
			else
				if	   sceltaLarghezzaRuote == 120
				then
					self:playAnimation("60r120DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 130
				then
					self:playAnimation("60r130DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 140
				then
					self:playAnimation("60r140DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 150
				then
					self:playAnimation("60r150DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 160
				then
					self:playAnimation("60r160DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 170
				then
					self:playAnimation("60r170DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 180
				then
					self:playAnimation("60r180DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 190
				then
					self:playAnimation("60r190DiscoSegnafila", 1, 0, true);
				end;
			end;
		elseif sceltaCorpiCorrente == 70
		then
			if sceltaPosizioneDisco == 1
			then
				self:playAnimation("70cDiscoSegnafila", 1, 0, true);
			else
				if	   sceltaLarghezzaRuote == 120
				then
					self:playAnimation("70r120DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 130
				then
					self:playAnimation("70r130DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 140
				then
					self:playAnimation("70r140DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 150
				then
					self:playAnimation("70r150DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 160
				then
					self:playAnimation("70r160DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 170
				then
					self:playAnimation("70r170DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 180
				then
					self:playAnimation("70r180DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 190
				then
					self:playAnimation("70r190DiscoSegnafila", 1, 0, true);
				end;
			end;
		elseif sceltaCorpiCorrente == 75
		then
			if sceltaPosizioneDisco == 1
			then
				self:playAnimation("75cDiscoSegnafila", 1, 0, true);
			else
				if	   sceltaLarghezzaRuote == 120
				then
					self:playAnimation("75r120DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 130
				then
					self:playAnimation("75r130DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 140
				then
					self:playAnimation("75r140DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 150
				then
					self:playAnimation("75r150DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 160
				then
					self:playAnimation("75r160DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 170
				then
					self:playAnimation("75r170DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 180
				then
					self:playAnimation("75r180DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 190
				then
					self:playAnimation("75r190DiscoSegnafila", 1, 0, true);
				end;
			end;
		elseif sceltaCorpiCorrente == 80
		then
			if sceltaPosizioneDisco == 1
			then
				self:playAnimation("80cDiscoSegnafila", 1, 0, true);
			else
				if	   sceltaLarghezzaRuote == 120
				then
					self:playAnimation("80r120DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 130
				then
					self:playAnimation("80r130DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 140
				then
					self:playAnimation("80r140DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 150
				then
					self:playAnimation("80r150DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 160
				then
					self:playAnimation("80r160DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 170
				then
					self:playAnimation("80r170DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 180
				then
					self:playAnimation("80r180DiscoSegnafila", 1, 0, true);
				elseif sceltaLarghezzaRuote == 190
				then
					self:playAnimation("80r190DiscoSegnafila", 1, 0, true);
				end;
			end;
		end;
	end;
	if sceltaMenuAttivo == self.menuSecondo
	or sceltaMenuAttivo == 0
		then
		if	   sceltaProfonditaCorpi == 1
		then
			self:playAnimation("01bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 2
		then
			self:playAnimation("02bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 3
		then
			self:playAnimation("03bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 4
		then
			self:playAnimation("04bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 5
		then
			self:playAnimation("05bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 6
		then
			self:playAnimation("06bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 7
		then
			self:playAnimation("07bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 8
		then
			self:playAnimation("08bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 9
		then
			self:playAnimation("09bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 10
		then
			self:playAnimation("10bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 11
		then
			self:playAnimation("11bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 12
		then
			self:playAnimation("12bilancieri", 1, 0, true);
		elseif sceltaProfonditaCorpi == 13
		then
			self:playAnimation("13bilancieri", 1, 0, true);
		end;
	end;
	if sceltaMenuAttivo == self.menuTerzo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaLeveCodini == 1
		then
			self:playAnimation("01codini", -1, 1, true);
		elseif sceltaLeveCodini == 2
		then
			self:playAnimation("01codini", 1, 0, true);
		elseif sceltaLeveCodini == 3
		then
			if self:getAnimationTime("03codini") == 0
			then
				self:playAnimation("02codini", 1, 0, true);
			else
				self:playAnimation("03codini", -1, 1, true);
			end;
		elseif sceltaLeveCodini == 4
		then
			if self:getAnimationTime("04codini") == 0
			then
				self:playAnimation("03codini", 1, 0, true);
			else
				self:playAnimation("04codini", -1, 1, true);
			end;
		elseif sceltaLeveCodini == 5
		then
			if self:getAnimationTime("05codini") == 0
			then
				self:playAnimation("04codini", 1, 0, true);
			else
				self:playAnimation("05codini", -1, 1, true);
			end;
		elseif sceltaLeveCodini == 6
		then
			if self:getAnimationTime("06codini") == 0
			then
				self:playAnimation("05codini", 1, 0, true);
			else
				self:playAnimation("06codini", -1, 1, true);
			end;
		elseif sceltaLeveCodini == 7
		then
			self:playAnimation("06codini", 1, 0, true);
		end;
	end;
	if sceltaMenuAttivo == self.menuQuarto
	or sceltaMenuAttivo == 0
	then
		if	   sceltaSelettoreCorpi == 1
		then
			self:playAnimation("01selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 2
		then
			self:playAnimation("02selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 3
		then
			self:playAnimation("03selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 4
		then
			self:playAnimation("04selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 5
		then
			self:playAnimation("05selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 6
		then
			self:playAnimation("06selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 7
		then
			self:playAnimation("07selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 8
		then
			self:playAnimation("08selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 9
		then
			self:playAnimation("09selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 10
		then
			self:playAnimation("10selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 11
		then
			self:playAnimation("11selettoreSemi", 1, 0, true);
		elseif sceltaSelettoreCorpi == 12
		then
			self:playAnimation("12selettoreSemi", 1, 0, true);
		end;
	end;
	if sceltaMenuAttivo == self.menuQuinto
	or sceltaMenuAttivo == 0
	then
		if	   sceltaSelettoreMicroG == 1
		then
			self:playAnimation("01selettoreMicroG", -1, 1, true);
		elseif sceltaSelettoreMicroG == 2
		then
			self:playAnimation("01selettoreMicroG", 1, 0, true);
		elseif sceltaSelettoreMicroG == 3
		then
			if self:getAnimationTime("03selettoreMicroG") == 0
			then
				self:playAnimation("02selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("03selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 4
		then
			if self:getAnimationTime("04selettoreMicroG") == 0
			then
				self:playAnimation("03selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("04selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 5
		then
			if self:getAnimationTime("05selettoreMicroG") == 0
			then
				self:playAnimation("04selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("05selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 6
		then
			if self:getAnimationTime("06selettoreMicroG") == 0
			then
				self:playAnimation("05selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("06selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 7
		then
			if self:getAnimationTime("07selettoreMicroG") == 0
			then
				self:playAnimation("06selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("07selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 8
		then
			if self:getAnimationTime("08selettoreMicroG") == 0
			then
				self:playAnimation("07selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("08selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 9
		then
			if self:getAnimationTime("09selettoreMicroG") == 0
			then
				self:playAnimation("08selettoreMicroG", 1, 0, true);
			else
				self:playAnimation("09selettoreMicroG", -1, 1, true);
			end;
		elseif sceltaSelettoreMicroG == 10
		then
			self:playAnimation("09selettoreMicroG", 1, 0, true);
		end;
	end;
	if sceltaMenuAttivo == self.menuSesto
	or sceltaMenuAttivo == 0
	then
		if	   sceltaCoperchiSemi == self.coperchiSemiAperti
		then
			self:playAnimation("coperchiSemi", 1, self:getAnimationTime("coperchiSemi"), true);
		elseif sceltaCoperchiSemi == self.coperchiSemiChiusi
		then
			self:playAnimation("coperchiSemi", -1, self:getAnimationTime("coperchiSemi"), true);
		end;
	end;
	if sceltaMenuAttivo == self.menuSettimo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaCoperchiMicroG == self.coperchiMicroGAperti
		then
			self:playAnimation("coperchiMicroG", 1, self:getAnimationTime("coperchiMicroG"), true);
		elseif sceltaCoperchiMicroG == self.coperchiMicroGChiusi
		then
			self:playAnimation("coperchiMicroG", -1, self:getAnimationTime("coperchiMicroG"), true);
		end;
	end;
	if sceltaMenuAttivo == self.menuOttavo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaRotazioneDisco == self.rotazioneDiscoEsterna
		then
			self:playAnimation("ruotaDiscoSegnafila", 1, self:getAnimationTime("ruotaDiscoSegnafila"), true);
		elseif sceltaRotazioneDisco == self.rotazioneDiscoInterna
		then
			self:playAnimation("ruotaDiscoSegnafila", -1, self:getAnimationTime("ruotaDiscoSegnafila"), true);
		end;
	end;
	if sceltaMenuAttivo == self.menuNono
	or sceltaMenuAttivo == 0
	then
		if	   sceltaSelezioneDisco == self.selezioneDiscoAperto
		then
			self:playAnimation("cambiaDiscoSegnafila", 1, self:getAnimationTime("cambiaDiscoSegnafila"), true);
		elseif sceltaSelezioneDisco == self.selezioneDiscoChiuso
		then
			self:playAnimation("cambiaDiscoSegnafila", -1, self:getAnimationTime("cambiaDiscoSegnafila"), true);
		end;
	end;
	if sceltaMenuAttivo == self.menuDecimo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaTagliente == 1
		then
			self:playAnimation("01tagliente", -1, 1, true);
		elseif sceltaTagliente == 2
		then
			self:playAnimation("01tagliente", 1, 0, true);
		elseif sceltaTagliente == 3
		then
			if self:getAnimationTime("03tagliente") == 0
			then
				self:playAnimation("02tagliente", 1, 0, true);
			else
				self:playAnimation("03tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 4
		then
			if self:getAnimationTime("04tagliente") == 0
			then
				self:playAnimation("03tagliente", 1, 0, true);
			else
				self:playAnimation("04tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 5
		then
			if self:getAnimationTime("05tagliente") == 0
			then
				self:playAnimation("04tagliente", 1, 0, true);
			else
				self:playAnimation("05tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 6
		then
			if self:getAnimationTime("06tagliente") == 0
			then
				self:playAnimation("05tagliente", 1, 0, true);
			else
				self:playAnimation("06tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 7
		then
			if self:getAnimationTime("07tagliente") == 0
			then
				self:playAnimation("06tagliente", 1, 0, true);
			else
				self:playAnimation("07tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 8
		then
			if self:getAnimationTime("08tagliente") == 0
			then
				self:playAnimation("07tagliente", 1, 0, true);
			else
				self:playAnimation("08tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 9
		then
			if self:getAnimationTime("09tagliente") == 0
			then
				self:playAnimation("08tagliente", 1, 0, true);
			else
				self:playAnimation("09tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 10
		then
			if self:getAnimationTime("10tagliente") == 0
			then
				self:playAnimation("09tagliente", 1, 0, true);
			else
				self:playAnimation("10tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 11
		then
			if self:getAnimationTime("11tagliente") == 0
			then
				self:playAnimation("10tagliente", 1, 0, true);
			else
				self:playAnimation("11tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 12
		then
			if self:getAnimationTime("12tagliente") == 0
			then
				self:playAnimation("11tagliente", 1, 0, true);
			else
				self:playAnimation("12tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 13
		then
			if self:getAnimationTime("13tagliente") == 0
			then
				self:playAnimation("12tagliente", 1, 0, true);
			else
				self:playAnimation("13tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 14
		then
			if self:getAnimationTime("14tagliente") == 0
			then
				self:playAnimation("13tagliente", 1, 0, true);
			else
				self:playAnimation("14tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 15
		then
			if self:getAnimationTime("15tagliente") == 0
			then
				self:playAnimation("14tagliente", 1, 0, true);
			else
				self:playAnimation("15tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 16
		then
			if self:getAnimationTime("16tagliente") == 0
			then
				self:playAnimation("15tagliente", 1, 0, true);
			else
				self:playAnimation("16tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 17
		then
			if self:getAnimationTime("17tagliente") == 0
			then
				self:playAnimation("16tagliente", 1, 0, true);
			else
				self:playAnimation("17tagliente", -1, 1, true);
			end;
		elseif sceltaTagliente == 18
		then
			self:playAnimation("17tagliente", 1, 0, true);
		end;
	end;
	if sceltaMenuAttivo == self.menuUndicesimo
	or sceltaMenuAttivo == 0
	then
		if	   sceltaSpianaterra == 1
		then
			self:playAnimation("01spianaterra", -1, 1, true);
		elseif sceltaSpianaterra == 2
		then
			self:playAnimation("01spianaterra", 1, 0, true);
		elseif sceltaSpianaterra == 3
		then
			if self:getAnimationTime("03spianaterra") == 0
			then
				self:playAnimation("02spianaterra", 1, 0, true);
			else
				self:playAnimation("03spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 4
		then
			if self:getAnimationTime("04spianaterra") == 0
			then
				self:playAnimation("03spianaterra", 1, 0, true);
			else
				self:playAnimation("04spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 5
		then
			if self:getAnimationTime("05spianaterra") == 0
			then
				self:playAnimation("04spianaterra", 1, 0, true);
			else
				self:playAnimation("05spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 6
		then
			if self:getAnimationTime("06spianaterra") == 0
			then
				self:playAnimation("05spianaterra", 1, 0, true);
			else
				self:playAnimation("06spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 7
		then
			if self:getAnimationTime("07spianaterra") == 0
			then
				self:playAnimation("06spianaterra", 1, 0, true);
			else
				self:playAnimation("07spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 8
		then
			if self:getAnimationTime("08spianaterra") == 0
			then
				self:playAnimation("07spianaterra", 1, 0, true);
			else
				self:playAnimation("08spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 9
		then
			if self:getAnimationTime("09spianaterra") == 0
			then
				self:playAnimation("08spianaterra", 1, 0, true);
			else
				self:playAnimation("09spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 10
		then
			if self:getAnimationTime("10spianaterra") == 0
			then
				self:playAnimation("09spianaterra", 1, 0, true);
			else
				self:playAnimation("10spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 11
		then
			if self:getAnimationTime("11spianaterra") == 0
			then
				self:playAnimation("10spianaterra", 1, 0, true);
			else
				self:playAnimation("11spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 12
		then
			if self:getAnimationTime("12spianaterra") == 0
			then
				self:playAnimation("11spianaterra", 1, 0, true);
			else
				self:playAnimation("12spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 13
		then
			if self:getAnimationTime("13spianaterra") == 0
			then
				self:playAnimation("12spianaterra", 1, 0, true);
			else
				self:playAnimation("13spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 14
		then
			if self:getAnimationTime("14spianaterra") == 0
			then
				self:playAnimation("13spianaterra", 1, 0, true);
			else
				self:playAnimation("14spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 15
		then
			if self:getAnimationTime("15spianaterra") == 0
			then
				self:playAnimation("14spianaterra", 1, 0, true);
			else
				self:playAnimation("15spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 16
		then
			if self:getAnimationTime("16spianaterra") == 0
			then
				self:playAnimation("15spianaterra", 1, 0, true);
			else
				self:playAnimation("16spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 17
		then
			if self:getAnimationTime("17spianaterra") == 0
			then
				self:playAnimation("16spianaterra", 1, 0, true);
			else
				self:playAnimation("17spianaterra", -1, 1, true);
			end;
		elseif sceltaSpianaterra == 18
		then
			self:playAnimation("17spianaterra", 1, 0, true);
		end;
	end;
	self.statoApertura = sceltaStatoApertura;
	self.tempoAttesa = sceltaTempoAttesa;
	self.corpiCorrente = sceltaCorpiCorrente;
	self.profonditaCorpi = sceltaProfonditaCorpi;
	self.leveCodini = sceltaLeveCodini;
	self.selettoreCorpi = sceltaSelettoreCorpi;
	self.selettoreMicroG = sceltaSelettoreMicroG;
	self.coperchiSemi = sceltaCoperchiSemi;
	self.coperchiMicroG = sceltaCoperchiMicroG;
	self.rotazioneDisco = sceltaRotazioneDisco;
	self.selezioneDisco = sceltaSelezioneDisco;
	self.tagliente = sceltaTagliente;
	self.spianaterra = sceltaSpianaterra;
	self.posizioneDisco = sceltaPosizioneDisco;
	self.larghezzaRuote = sceltaLarghezzaRuote;
	if sceltaMenuAttivo > 0
	then
		self.menuAttivo = sceltaMenuAttivo;
	end;
end;
setStatoMagicaEvent = {};
setStatoMagicaEvent_mt = Class(setStatoMagicaEvent, Event);
InitEventClass(setStatoMagicaEvent, "setStatoMagicaEvent");
function setStatoMagicaEvent:emptyNew()
	local self = Event:new(setStatoMagicaEvent_mt);
	self.className="setStatoMagicaEvent";
	return self;
end;
function setStatoMagicaEvent:new(object, sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo)
	local self = setStatoMagicaEvent:emptyNew()
	self.object = object;
	self.sceltaStatoApertura = sceltaStatoApertura;
	self.sceltaTempoAttesa = sceltaTempoAttesa;
	self.sceltaCorpiCorrente = sceltaCorpiCorrente;
	self.sceltaProfonditaCorpi = sceltaProfonditaCorpi;
	self.sceltaLeveCodini = sceltaLeveCodini;
	self.sceltaSelettoreCorpi = sceltaSelettoreCorpi;
	self.sceltaSelettoreMicroG = sceltaSelettoreMicroG;
	self.sceltaCoperchiSemi = sceltaCoperchiSemi;
	self.sceltaCoperchiMicroG = sceltaCoperchiMicroG;
	self.sceltaRotazioneDisco = sceltaRotazioneDisco;
	self.sceltaSelezioneDisco = sceltaSelezioneDisco;
	self.sceltaTagliente = sceltaTagliente;
	self.sceltaSpianaterra = sceltaSpianaterra;
	self.sceltaPosizioneDisco = sceltaPosizioneDisco;
	self.sceltaLarghezzaRuote = sceltaLarghezzaRuote;
	self.sceltaMenuAttivo = sceltaMenuAttivo;
	return self;
end;
function setStatoMagicaEvent:readStream(streamId, connection)
	self.object = readNetworkNodeObject(streamId);
	self.sceltaStatoApertura = streamReadInt8(streamId);
	self.sceltaTempoAttesa = streamReadInt8(streamId);
	self.sceltaCorpiCorrente = streamReadInt8(streamId);
	self.sceltaProfonditaCorpi = streamReadInt8(streamId);
	self.sceltaLeveCodini = streamReadInt8(streamId);
	self.sceltaSelettoreCorpi = streamReadInt8(streamId);
	self.sceltaSelettoreMicroG = streamReadInt8(streamId);
	self.sceltaCoperchiSemi = streamReadInt8(streamId);
	self.sceltaCoperchiMicroG = streamReadInt8(streamId);
	self.sceltaRotazioneDisco = streamReadInt8(streamId);
	self.sceltaSelezioneDisco = streamReadInt8(streamId);
	self.sceltaTagliente = streamReadInt8(streamId);
	self.sceltaSpianaterra = streamReadInt8(streamId);
	self.sceltaPosizioneDisco = streamReadInt8(streamId);
	self.sceltaLarghezzaRuote = streamReadInt8(streamId);
	self.sceltaMenuAttivo = streamReadInt8(streamId);
	self:run(connection);
end;
function setStatoMagicaEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.object);
	streamWriteInt8(streamId, self.sceltaStatoApertura);
	streamWriteInt8(streamId, self.sceltaTempoAttesa);
	streamWriteInt8(streamId, self.sceltaCorpiCorrente);
	streamWriteInt8(streamId, self.sceltaProfonditaCorpi);
	streamWriteInt8(streamId, self.sceltaLeveCodini);
	streamWriteInt8(streamId, self.sceltaSelettoreCorpi);
	streamWriteInt8(streamId, self.sceltaSelettoreMicroG);
	streamWriteInt8(streamId, self.sceltaCoperchiSemi);
	streamWriteInt8(streamId, self.sceltaCoperchiMicroG);
	streamWriteInt8(streamId, self.sceltaRotazioneDisco);
	streamWriteInt8(streamId, self.sceltaSelezioneDisco);
	streamWriteInt8(streamId, self.sceltaTagliente);
	streamWriteInt8(streamId, self.sceltaSpianaterra);
	streamWriteInt8(streamId, self.sceltaPosizioneDisco);
	streamWriteInt8(streamId, self.sceltaLarghezzaRuote);
	streamWriteInt8(streamId, self.sceltaMenuAttivo);
end;
function setStatoMagicaEvent:run(connection)
	if not connection:getIsServer()
	then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil
	then
		self.object:setStatoMagica(self.sceltaStatoApertura, self.sceltaTempoAttesa, self.sceltaCorpiCorrente, self.sceltaProfonditaCorpi, self.sceltaLeveCodini, self.sceltaSelettoreCorpi, self.sceltaSelettoreMicroG, self.sceltaCoperchiSemi, self.sceltaCoperchiMicroG, self.sceltaRotazioneDisco, self.sceltaSelezioneDisco, self.sceltaTagliente, self.sceltaSpianaterra, self.sceltaPosizioneDisco, self.sceltaLarghezzaRuote, self.sceltaMenuAttivo, true);
	end;
end;
function setStatoMagicaEvent.sendEvent(vehicle, sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo, noEventSend)
	if noEventSend == nil
	or noEventSend == false
	then
		if g_server ~= nil
		then
			g_server:broadcastEvent(setStatoMagicaEvent:new(vehicle, sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(setStatoMagicaEvent:new(vehicle, sceltaStatoApertura, sceltaTempoAttesa, sceltaCorpiCorrente, sceltaProfonditaCorpi, sceltaLeveCodini, sceltaSelettoreCorpi, sceltaSelettoreMicroG, sceltaCoperchiSemi, sceltaCoperchiMicroG, sceltaRotazioneDisco, sceltaSelezioneDisco, sceltaTagliente, sceltaSpianaterra, sceltaPosizioneDisco, sceltaLarghezzaRuote, sceltaMenuAttivo));
		end;
	end;
end;
function magica:setMenuMagicaAttivo(sceltaMenuMagicaAttivo, noEventSend)
	setMenuMagicaAttivoEvent.sendEvent(self, sceltaMenuMagicaAttivo, noEventSend);
	self.menuMagicaAttivo = sceltaMenuMagicaAttivo;
end;
setMenuMagicaAttivoEvent = {};
setMenuMagicaAttivoEvent_mt = Class(setMenuMagicaAttivoEvent, Event);
InitEventClass(setMenuMagicaAttivoEvent, "setMenuMagicaAttivoEvent");
function setMenuMagicaAttivoEvent:emptyNew()
	local self = Event:new(setMenuMagicaAttivoEvent_mt);
	self.className="setMenuMagicaAttivoEvent";
	return self;
end;
function setMenuMagicaAttivoEvent:new(object, sceltaMenuMagicaAttivo)
	local self = setMenuMagicaAttivoEvent:emptyNew();
	self.object = object;
	self.sceltaMenuMagicaAttivo = sceltaMenuMagicaAttivo;
	return self;
end;
function setMenuMagicaAttivoEvent:readStream(streamId, connection)
	self.object = readNetworkNodeObject(streamId);
	self.sceltaMenuMagicaAttivo = streamReadBool(streamId);
	self:run(connection);
end;
function setMenuMagicaAttivoEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.sceltaMenuMagicaAttivo);
end;
function setMenuMagicaAttivoEvent:run(connection)
	if not connection:getIsServer()
	then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil
	then
		self.object:setMenuMagicaAttivo(self.sceltaMenuMagicaAttivo, true);
	end;
end;
function setMenuMagicaAttivoEvent.sendEvent(vehicle, sceltaMenuMagicaAttivo, noEventSend)
	if noEventSend == nil
	or noEventSend == false
	then
		if g_server ~= nil
		then
			g_server:broadcastEvent(setMenuMagicaAttivoEvent:new(vehicle, sceltaMenuMagicaAttivo), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(setMenuMagicaAttivoEvent:new(vehicle, sceltaMenuMagicaAttivo));
		end;
	end;
end;
function magica:setEsclusioneCorpi(sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08, noEventSend)
	setEsclusioneCorpiEvent.sendEvent(self, sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08, noEventSend);
	if sceltaEsclusioneCorpo01
	then
		self:playAnimation("esclusione01", 1, 0, true);
	else
		self:playAnimation("esclusione01", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo02
	then
		self:playAnimation("esclusione02", 1, 0, true);
	else
		self:playAnimation("esclusione02", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo03
	then
		self:playAnimation("esclusione03", 1, 0, true);
	else
		self:playAnimation("esclusione03", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo04
	then
		self:playAnimation("esclusione04", 1, 0, true);
	else
		self:playAnimation("esclusione04", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo05
	then
		self:playAnimation("esclusione05", 1, 0, true);
	else
		self:playAnimation("esclusione05", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo06
	then
		self:playAnimation("esclusione06", 1, 0, true);
	else
		self:playAnimation("esclusione06", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo07
	then
		self:playAnimation("esclusione07", 1, 0, true);
	else
		self:playAnimation("esclusione07", -1, 0, true);
	end;
	if sceltaEsclusioneCorpo08
	then
		self:playAnimation("esclusione08", 1, 0, true);
	else
		self:playAnimation("esclusione08", -1, 0, true);
	end;
	self.esclusioneCorpo01 = sceltaEsclusioneCorpo01;
	self.esclusioneCorpo02 = sceltaEsclusioneCorpo02;
	self.esclusioneCorpo03 = sceltaEsclusioneCorpo03;
	self.esclusioneCorpo04 = sceltaEsclusioneCorpo04;
	self.esclusioneCorpo05 = sceltaEsclusioneCorpo05;
	self.esclusioneCorpo06 = sceltaEsclusioneCorpo06;
	self.esclusioneCorpo07 = sceltaEsclusioneCorpo07;
	self.esclusioneCorpo08 = sceltaEsclusioneCorpo08;
end;
setEsclusioneCorpiEvent = {};
setEsclusioneCorpiEvent_mt = Class(setEsclusioneCorpiEvent, Event);
InitEventClass(setEsclusioneCorpiEvent, "setEsclusioneCorpiEvent");
function setEsclusioneCorpiEvent:emptyNew()
	local self = Event:new(setEsclusioneCorpiEvent_mt);
	self.className="setEsclusioneCorpiEvent";
	return self;
end;
function setEsclusioneCorpiEvent:new(object, sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08)
	local self = setEsclusioneCorpiEvent:emptyNew();
	self.object = object;
	self.sceltaEsclusioneCorpo01 = sceltaEsclusioneCorpo01;
	self.sceltaEsclusioneCorpo02 = sceltaEsclusioneCorpo02;
	self.sceltaEsclusioneCorpo03 = sceltaEsclusioneCorpo03;
	self.sceltaEsclusioneCorpo04 = sceltaEsclusioneCorpo04;
	self.sceltaEsclusioneCorpo05 = sceltaEsclusioneCorpo05;
	self.sceltaEsclusioneCorpo06 = sceltaEsclusioneCorpo06;
	self.sceltaEsclusioneCorpo07 = sceltaEsclusioneCorpo07;
	self.sceltaEsclusioneCorpo08 = sceltaEsclusioneCorpo08;
	return self;
end;
function setEsclusioneCorpiEvent:readStream(streamId, connection)
	self.object = readNetworkNodeObject(streamId);
	self.sceltaEsclusioneCorpo01 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo02 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo03 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo04 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo05 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo06 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo07 = streamReadBool(streamId);
	self.sceltaEsclusioneCorpo08 = streamReadBool(streamId);
	self:run(connection);
end;
function setEsclusioneCorpiEvent:writeStream(streamId, connection)
	writeNetworkNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo01);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo02);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo03);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo04);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo05);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo06);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo07);
	streamWriteBool(streamId, self.sceltaEsclusioneCorpo08);
end;
function setEsclusioneCorpiEvent:run(connection)
	if not connection:getIsServer()
	then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil
	then
		self.object:setEsclusioneCorpi(self.sceltaEsclusioneCorpo01, self.sceltaEsclusioneCorpo02, self.sceltaEsclusioneCorpo03, self.sceltaEsclusioneCorpo04, self.sceltaEsclusioneCorpo05, self.sceltaEsclusioneCorpo06, self.sceltaEsclusioneCorpo07, self.sceltaEsclusioneCorpo08, true);
	end;
end;
function setEsclusioneCorpiEvent.sendEvent(vehicle, sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08, noEventSend)
	if noEventSend == nil
	or noEventSend == false
	then
		if g_server ~= nil
		then
			g_server:broadcastEvent(setEsclusioneCorpiEvent:new(vehicle, sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(setEsclusioneCorpiEvent:new(vehicle, sceltaEsclusioneCorpo01, sceltaEsclusioneCorpo02, sceltaEsclusioneCorpo03, sceltaEsclusioneCorpo04, sceltaEsclusioneCorpo05, sceltaEsclusioneCorpo06, sceltaEsclusioneCorpo07, sceltaEsclusioneCorpo08));
		end;
	end;
end;